type token =
  | IDENTIFIER of (string)
  | STRING_LITERAL of (string)
  | TYPENAME of (string)
  | CONSTANT of (Logic_ptree.constant)
  | LPAR
  | RPAR
  | IF
  | ELSE
  | COLON
  | COLON2
  | COLONCOLON
  | DOT
  | DOTDOT
  | DOTDOTDOT
  | INT
  | INTEGER
  | REAL
  | FLOAT
  | LT
  | GT
  | LE
  | GE
  | EQ
  | NE
  | COMMA
  | ARROW
  | EQUAL
  | FORALL
  | EXISTS
  | IFF
  | IMPLIES
  | AND
  | OR
  | NOT
  | SEPARATED
  | TRUE
  | FALSE
  | OLD
  | AT
  | RESULT
  | BLOCK_LENGTH
  | BASE_ADDR
  | VALID
  | VALID_INDEX
  | VALID_RANGE
  | FRESH
  | DOLLAR
  | QUESTION
  | MINUS
  | PLUS
  | STAR
  | AMP
  | SLASH
  | PERCENT
  | LSQUARE
  | RSQUARE
  | EOF
  | GLOBAL
  | INVARIANT
  | VARIANT
  | DECREASES
  | FOR
  | LABEL
  | ASSERT
  | SEMICOLON
  | NULL
  | EMPTY
  | REQUIRES
  | ENSURES
  | ASSIGNS
  | LOOP
  | NOTHING
  | SLICE
  | IMPACT
  | PRAGMA
  | FROM
  | READS
  | LOGIC
  | PREDICATE
  | INDUCTIVE
  | AXIOMATIC
  | AXIOM
  | LEMMA
  | LBRACE
  | RBRACE
  | GHOST
  | CASE
  | VOID
  | CHAR
  | SIGNED
  | UNSIGNED
  | SHORT
  | LONG
  | DOUBLE
  | STRUCT
  | ENUM
  | UNION
  | BSUNION
  | INTER
  | LTCOLON
  | COLONGT
  | TYPE
  | BEHAVIOR
  | BEHAVIORS
  | ASSUMES
  | COMPLETE
  | DISJOINT
  | TERMINATES
  | HAT
  | HATHAT
  | PIPE
  | TILDE
  | GTGT
  | LTLT
  | SIZEOF
  | LAMBDA
  | TYPEOF
  | BSTYPE

open Parsing;;
# 27 "cil/src/logic/logic_parser.mly"

  open Cil
  open Cil_types
  open Logic_ptree
  open Logic_const

  let loc () = (symbol_start_pos (), symbol_end_pos ())
  let loc_i i = (rhs_start i, rhs_end i)
  let info x = { lexpr_node = x; lexpr_loc = loc () }
  let loc_info loc x = { lexpr_node = x; lexpr_loc = loc }
  let loc_start x = fst x.lexpr_loc
  let loc_end x = snd x.lexpr_loc

  type sense_of_relation = Unknown | Equal | Disequal | Less | Greater

  let relation_sense rel sense =
    match rel, sense with
        Eq, _ -> sense, true
      | Neq, Unknown -> Disequal, true (* No chain of disequality for now*)
      | (Gt|Ge), (Unknown|Equal|Greater) -> Greater, true
      | (Lt|Le), (Unknown|Equal|Less) -> Less, true
      | _ -> sense, false

# 147 "cil/src/logic/logic_parser.ml"
let yytransl_const = [|
  261 (* LPAR *);
  262 (* RPAR *);
  263 (* IF *);
  264 (* ELSE *);
  265 (* COLON *);
  266 (* COLON2 *);
  267 (* COLONCOLON *);
  268 (* DOT *);
  269 (* DOTDOT *);
  270 (* DOTDOTDOT *);
  271 (* INT *);
  272 (* INTEGER *);
  273 (* REAL *);
  274 (* FLOAT *);
  275 (* LT *);
  276 (* GT *);
  277 (* LE *);
  278 (* GE *);
  279 (* EQ *);
  280 (* NE *);
  281 (* COMMA *);
  282 (* ARROW *);
  283 (* EQUAL *);
  284 (* FORALL *);
  285 (* EXISTS *);
  286 (* IFF *);
  287 (* IMPLIES *);
  288 (* AND *);
  289 (* OR *);
  290 (* NOT *);
  291 (* SEPARATED *);
  292 (* TRUE *);
  293 (* FALSE *);
  294 (* OLD *);
  295 (* AT *);
  296 (* RESULT *);
  297 (* BLOCK_LENGTH *);
  298 (* BASE_ADDR *);
  299 (* VALID *);
  300 (* VALID_INDEX *);
  301 (* VALID_RANGE *);
  302 (* FRESH *);
  303 (* DOLLAR *);
  304 (* QUESTION *);
  305 (* MINUS *);
  306 (* PLUS *);
  307 (* STAR *);
  308 (* AMP *);
  309 (* SLASH *);
  310 (* PERCENT *);
  311 (* LSQUARE *);
  312 (* RSQUARE *);
    0 (* EOF *);
  313 (* GLOBAL *);
  314 (* INVARIANT *);
  315 (* VARIANT *);
  316 (* DECREASES *);
  317 (* FOR *);
  318 (* LABEL *);
  319 (* ASSERT *);
  320 (* SEMICOLON *);
  321 (* NULL *);
  322 (* EMPTY *);
  323 (* REQUIRES *);
  324 (* ENSURES *);
  325 (* ASSIGNS *);
  326 (* LOOP *);
  327 (* NOTHING *);
  328 (* SLICE *);
  329 (* IMPACT *);
  330 (* PRAGMA *);
  331 (* FROM *);
  332 (* READS *);
  333 (* LOGIC *);
  334 (* PREDICATE *);
  335 (* INDUCTIVE *);
  336 (* AXIOMATIC *);
  337 (* AXIOM *);
  338 (* LEMMA *);
  339 (* LBRACE *);
  340 (* RBRACE *);
  341 (* GHOST *);
  342 (* CASE *);
  343 (* VOID *);
  344 (* CHAR *);
  345 (* SIGNED *);
  346 (* UNSIGNED *);
  347 (* SHORT *);
  348 (* LONG *);
  349 (* DOUBLE *);
  350 (* STRUCT *);
  351 (* ENUM *);
  352 (* UNION *);
  353 (* BSUNION *);
  354 (* INTER *);
  355 (* LTCOLON *);
  356 (* COLONGT *);
  357 (* TYPE *);
  358 (* BEHAVIOR *);
  359 (* BEHAVIORS *);
  360 (* ASSUMES *);
  361 (* COMPLETE *);
  362 (* DISJOINT *);
  363 (* TERMINATES *);
  364 (* HAT *);
  365 (* HATHAT *);
  366 (* PIPE *);
  367 (* TILDE *);
  368 (* GTGT *);
  369 (* LTLT *);
  370 (* SIZEOF *);
  371 (* LAMBDA *);
  372 (* TYPEOF *);
  373 (* BSTYPE *);
    0|]

let yytransl_block = [|
  257 (* IDENTIFIER *);
  258 (* STRING_LITERAL *);
  259 (* TYPENAME *);
  260 (* CONSTANT *);
    0|]

let yylhs = "\255\255\
\004\000\005\000\006\000\006\000\007\000\007\000\008\000\008\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\018\000\018\000\018\000\018\000\018\000\
\018\000\012\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\010\000\010\000\019\000\019\000\017\000\020\000\020\000\020\000\
\020\000\020\000\023\000\023\000\024\000\024\000\024\000\021\000\
\022\000\022\000\027\000\027\000\027\000\027\000\026\000\026\000\
\026\000\028\000\028\000\029\000\031\000\032\000\013\000\035\000\
\035\000\030\000\030\000\037\000\037\000\034\000\034\000\038\000\
\038\000\038\000\038\000\038\000\038\000\040\000\040\000\025\000\
\025\000\039\000\039\000\036\000\036\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\033\000\033\000\
\041\000\042\000\043\000\044\000\045\000\047\000\048\000\049\000\
\050\000\050\000\052\000\052\000\053\000\053\000\054\000\054\000\
\054\000\055\000\055\000\056\000\056\000\058\000\057\000\059\000\
\059\000\060\000\060\000\060\000\003\000\062\000\062\000\062\000\
\062\000\062\000\062\000\062\000\063\000\063\000\063\000\063\000\
\068\000\068\000\069\000\070\000\070\000\064\000\064\000\066\000\
\061\000\061\000\071\000\071\000\071\000\071\000\071\000\074\000\
\067\000\075\000\072\000\072\000\073\000\073\000\065\000\051\000\
\051\000\051\000\076\000\046\000\046\000\077\000\078\000\078\000\
\078\000\078\000\011\000\080\000\080\000\081\000\082\000\082\000\
\082\000\082\000\083\000\083\000\083\000\083\000\083\000\084\000\
\084\000\084\000\086\000\086\000\087\000\087\000\087\000\087\000\
\087\000\085\000\085\000\015\000\015\000\079\000\079\000\014\000\
\002\000\089\000\089\000\088\000\088\000\088\000\088\000\088\000\
\090\000\090\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\000\000\000\000\000\000"

let yylen = "\002\000\
\000\000\000\000\000\000\001\000\001\000\003\000\001\000\002\000\
\002\000\001\000\001\000\004\000\006\000\008\000\004\000\001\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\004\000\004\000\002\000\002\000\002\000\002\000\002\000\004\000\
\004\000\004\000\006\000\004\000\004\000\001\000\004\000\004\000\
\007\000\004\000\001\000\003\000\003\000\003\000\003\000\004\000\
\003\000\003\000\003\000\004\000\005\000\001\000\004\000\004\000\
\005\000\007\000\007\000\001\000\001\000\001\000\001\000\001\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\004\000\
\004\000\004\000\003\000\003\000\003\000\005\000\003\000\001\000\
\002\000\003\000\000\000\001\000\001\000\001\000\003\000\003\000\
\002\000\004\000\001\000\002\000\001\000\004\000\004\000\002\000\
\001\000\002\000\001\000\004\000\003\000\004\000\000\000\001\000\
\003\000\001\000\003\000\001\000\001\000\004\000\002\000\001\000\
\003\000\002\000\002\000\002\000\002\000\000\000\001\000\001\000\
\001\000\002\000\002\000\003\000\002\000\003\000\004\000\001\000\
\002\000\003\000\004\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\002\000\001\000\002\000\002\000\001\000\001\000\
\002\000\002\000\001\000\002\000\002\000\003\000\002\000\003\000\
\002\000\003\000\003\000\003\000\004\000\004\000\001\000\001\000\
\002\000\002\000\002\000\002\000\001\000\004\000\001\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\001\000\001\000\000\000\004\000\000\000\001\000\004\000\004\000\
\004\000\000\000\005\000\003\000\001\000\002\000\003\000\001\000\
\003\000\000\000\005\000\005\000\004\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\009\000\003\000\001\000\007\000\004\000\004\000\
\000\000\003\000\001\000\001\000\006\000\003\000\003\000\002\000\
\004\000\002\000\004\000\003\000\005\000\004\000\004\000\001\000\
\003\000\003\000\001\000\001\000\003\000\001\000\001\000\004\000\
\004\000\007\000\001\000\000\000\001\000\003\000\001\000\001\000\
\006\000\001\000\007\000\006\000\006\000\005\000\005\000\005\000\
\004\000\003\000\000\000\002\000\001\000\005\000\004\000\003\000\
\005\000\000\000\006\000\001\000\003\000\001\000\003\000\001\000\
\002\000\001\000\002\000\001\000\002\000\001\000\001\000\001\000\
\001\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\002\000\002\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\243\000\017\000\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\000\000\000\000\038\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\016\000\054\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\080\000\000\000\000\000\
\024\001\000\000\001\000\202\000\001\000\001\000\198\000\200\000\
\201\000\000\000\000\000\000\000\001\000\001\000\001\000\000\000\
\001\000\000\000\199\000\204\000\203\000\141\001\000\000\000\000\
\205\000\206\000\207\000\208\000\022\001\250\000\023\001\219\000\
\220\000\000\000\000\000\000\000\247\000\248\000\000\000\020\001\
\001\000\142\001\000\000\000\000\140\000\134\000\135\000\159\000\
\136\000\137\000\000\000\000\000\144\000\000\000\160\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\086\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\060\000\061\000\
\062\000\063\000\064\000\065\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\008\000\
\000\000\000\000\000\000\001\000\001\000\000\000\000\000\000\000\
\000\000\000\000\000\000\001\000\001\000\001\000\224\000\226\000\
\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\
\001\000\000\000\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\057\001\058\001\059\001\060\001\139\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\082\001\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\097\001\098\001\099\001\100\001\101\001\102\001\103\001\
\104\001\105\001\106\001\107\001\108\001\109\001\110\001\111\001\
\112\001\113\001\114\001\115\001\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\133\001\124\001\132\001\134\001\
\135\001\125\001\126\001\127\001\128\001\129\001\130\001\131\001\
\136\001\137\001\138\001\021\001\000\000\001\000\210\000\001\000\
\000\000\019\001\017\001\000\000\001\000\001\000\001\000\000\000\
\182\000\000\000\000\000\000\000\141\000\138\000\145\000\000\000\
\142\000\139\000\146\000\000\000\151\000\000\000\161\000\162\000\
\163\000\164\000\046\000\047\000\000\000\000\000\128\000\000\000\
\000\000\111\000\119\000\120\000\000\000\000\000\093\000\089\000\
\000\000\000\000\000\000\099\000\096\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\075\000\000\000\000\000\000\000\024\000\
\023\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\050\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\223\000\002\000\001\000\000\000\
\222\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\132\000\000\000\133\000\000\000\002\000\000\000\001\000\001\000\
\001\000\000\000\245\000\000\000\000\000\001\000\000\000\002\001\
\026\001\000\000\000\000\000\000\228\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\001\000\190\000\000\000\000\000\
\000\000\000\000\000\000\150\000\000\000\152\000\000\000\156\000\
\000\000\000\000\129\000\000\000\000\000\122\000\000\000\000\000\
\125\000\066\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\087\000\088\000\000\000\000\000\040\000\
\034\000\001\000\037\000\036\000\012\000\000\000\000\000\015\000\
\000\000\000\000\000\000\055\000\056\000\032\000\033\000\000\000\
\052\000\000\000\000\000\026\000\025\000\082\000\039\000\000\000\
\001\000\001\000\169\000\170\000\193\000\001\000\000\000\215\000\
\001\000\216\000\178\000\000\000\235\000\002\000\177\000\000\000\
\000\000\231\000\230\000\000\000\000\000\117\000\116\000\175\000\
\000\000\000\000\000\000\016\001\000\000\000\000\000\000\001\000\
\001\001\000\000\001\000\001\000\001\000\001\000\005\001\000\000\
\000\000\000\000\001\000\000\000\002\000\225\000\227\000\180\000\
\000\000\000\000\000\000\000\000\188\000\000\000\001\000\001\000\
\001\000\197\000\166\000\000\000\157\000\158\000\126\000\000\000\
\124\000\000\000\000\000\106\000\108\000\000\000\000\000\000\000\
\000\000\101\000\000\000\000\000\090\000\006\000\000\000\000\000\
\000\000\000\000\000\000\057\000\053\000\000\000\000\000\013\001\
\000\000\000\000\001\000\212\000\176\000\000\000\000\000\229\000\
\000\000\001\000\000\001\240\000\001\000\000\000\000\000\002\000\
\246\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\
\255\000\004\001\254\000\000\000\000\000\174\000\184\000\185\000\
\183\000\191\000\000\000\000\000\000\000\000\000\168\000\131\000\
\127\000\000\000\115\000\114\000\095\000\094\000\102\000\100\000\
\035\000\013\000\000\000\000\000\000\000\000\000\249\000\221\000\
\000\000\234\000\233\000\237\000\110\000\000\000\015\001\001\000\
\000\000\171\000\252\000\000\000\253\000\000\000\000\000\001\000\
\008\001\002\000\000\000\000\000\000\000\000\000\218\000\105\000\
\107\000\000\000\059\000\058\000\041\000\214\000\251\000\000\000\
\113\000\000\000\000\000\007\001\000\000\172\000\001\000\187\000\
\195\000\196\000\014\000\242\000\000\000\006\001\009\001\000\000\
\000\000\211\000\011\001"

let yydgoto = "\004\000\
\099\001\062\000\082\000\168\000\251\001\111\001\112\001\038\000\
\039\000\160\000\040\000\100\000\101\000\019\002\145\001\161\001\
\106\000\161\000\103\000\107\000\108\000\093\001\088\001\089\001\
\094\001\058\002\095\001\059\002\060\002\061\002\062\002\163\001\
\194\001\082\001\096\002\063\002\195\001\083\001\084\001\085\001\
\155\001\180\000\023\002\109\002\000\000\005\002\180\001\179\000\
\158\001\006\002\007\002\083\000\056\001\057\001\190\001\058\001\
\188\001\059\001\170\000\193\001\050\002\063\000\064\000\065\000\
\066\000\067\000\068\000\069\000\070\000\156\001\071\000\072\000\
\073\000\074\000\075\000\008\002\009\002\181\000\021\002\170\001\
\171\001\076\000\077\000\078\000\100\002\032\002\033\002\079\000\
\080\000\044\001\045\001"

let yysindex = "\188\001\
\153\014\117\015\007\255\000\000\000\000\000\000\040\013\080\012\
\080\012\065\015\124\255\000\000\000\000\153\255\166\255\000\000\
\186\255\210\255\228\255\239\255\015\000\044\000\065\015\065\015\
\065\015\065\015\000\000\000\000\153\014\055\000\086\000\065\015\
\112\000\080\012\129\000\135\000\028\014\000\000\080\007\040\255\
\000\000\229\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\101\000\197\255\245\255\000\000\000\000\000\000\105\000\
\000\000\087\000\000\000\000\000\000\000\000\000\179\012\005\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\106\000\165\000\011\001\000\000\000\000\171\001\000\000\
\000\000\000\000\020\000\155\000\000\000\000\000\000\000\000\000\
\000\000\000\000\144\255\171\255\000\000\017\255\000\000\105\000\
\105\000\105\000\059\255\171\000\173\000\011\000\167\000\173\255\
\207\255\118\000\158\000\000\000\123\000\026\255\011\255\153\014\
\153\014\153\014\153\014\153\014\153\014\153\014\153\014\153\014\
\026\255\026\255\026\255\026\255\078\005\153\014\153\014\026\255\
\040\013\132\000\153\014\238\004\153\014\153\014\153\014\153\014\
\153\014\153\014\153\014\153\014\153\014\105\000\000\000\000\000\
\000\000\000\000\000\000\000\000\105\000\065\015\065\015\065\015\
\065\015\065\015\153\014\065\015\143\013\065\015\065\015\000\000\
\065\015\153\014\153\014\000\000\000\000\153\014\133\000\105\000\
\175\000\192\000\138\000\000\000\000\000\000\000\000\000\000\000\
\203\000\080\012\000\000\255\254\201\000\201\000\134\000\209\000\
\000\000\156\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\179\012\000\000\000\000\000\000\
\159\000\000\000\000\000\161\000\000\000\000\000\000\000\120\000\
\000\000\117\000\209\254\080\012\000\000\000\000\000\000\029\255\
\000\000\000\000\000\000\068\255\000\000\213\000\000\000\000\000\
\000\000\000\000\000\000\000\000\065\015\011\000\000\000\153\014\
\185\255\000\000\000\000\000\000\032\000\153\014\000\000\000\000\
\041\000\105\000\207\255\000\000\000\000\050\000\049\000\153\014\
\050\006\153\014\072\005\225\000\072\255\138\006\110\001\183\002\
\218\002\147\006\146\011\036\003\105\000\040\013\226\000\000\000\
\227\000\072\003\230\000\153\014\146\003\186\000\126\005\126\005\
\118\255\157\255\162\000\000\000\188\000\182\255\235\254\000\000\
\000\000\195\255\195\255\026\255\026\255\026\255\240\010\185\000\
\026\255\026\255\000\000\065\004\065\004\080\007\239\000\028\014\
\163\000\221\000\243\000\028\014\000\000\000\000\000\000\212\255\
\000\000\184\000\194\000\193\000\241\013\195\000\196\000\244\000\
\000\000\011\000\000\000\011\000\000\000\201\000\000\000\000\000\
\000\000\136\255\000\000\182\000\145\001\000\000\006\001\000\000\
\000\000\003\001\153\014\210\000\000\000\211\000\007\255\212\000\
\214\000\218\000\153\014\020\000\000\000\000\000\174\000\180\000\
\228\000\009\001\005\001\000\000\018\001\000\000\019\001\000\000\
\026\255\030\001\000\000\028\014\237\000\000\000\032\000\080\012\
\000\000\000\000\080\012\153\014\041\000\032\001\049\000\080\012\
\153\014\028\014\173\255\000\000\000\000\028\014\153\014\000\000\
\000\000\000\000\000\000\000\000\000\000\153\014\153\014\000\000\
\013\001\174\255\252\254\000\000\000\000\000\000\000\000\028\014\
\000\000\035\001\153\014\000\000\000\000\000\000\000\000\038\001\
\000\000\000\000\000\000\000\000\000\000\000\000\242\000\000\000\
\000\000\000\000\000\000\028\014\000\000\000\000\000\000\229\000\
\020\001\000\000\000\000\238\000\080\012\000\000\000\000\000\000\
\146\255\031\001\025\001\000\000\224\000\080\012\048\001\000\000\
\000\000\232\000\000\000\000\000\000\000\000\000\000\000\231\000\
\145\001\249\000\000\000\246\000\000\000\000\000\000\000\000\000\
\020\000\020\000\020\000\174\006\000\000\054\001\000\000\000\000\
\000\000\000\000\000\000\080\012\000\000\000\000\000\000\010\001\
\000\000\063\001\045\001\000\000\000\000\207\255\207\255\065\001\
\016\001\000\000\070\001\021\001\000\000\000\000\072\001\003\004\
\063\013\153\014\153\014\000\000\000\000\028\014\153\014\000\000\
\015\001\017\001\000\000\000\000\000\000\069\014\153\014\000\000\
\060\001\000\000\000\000\000\000\000\000\064\001\057\001\000\000\
\000\000\028\001\094\001\022\001\000\000\201\000\095\001\041\001\
\000\000\000\000\000\000\080\012\093\001\000\000\000\000\000\000\
\000\000\000\000\020\000\046\001\049\001\050\001\000\000\000\000\
\000\000\236\015\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\153\014\033\014\116\014\103\001\000\000\000\000\
\053\001\000\000\000\000\000\000\000\000\055\001\000\000\000\000\
\080\012\000\000\000\000\109\001\000\000\201\000\220\255\000\000\
\000\000\000\000\097\001\117\000\209\254\209\254\000\000\000\000\
\000\000\036\004\000\000\000\000\000\000\000\000\000\000\105\001\
\000\000\153\014\253\255\000\000\062\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\050\011\000\000\000\000\067\001\
\232\000\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\042\000\000\000\000\000\000\000\115\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\129\002\000\000\177\011\032\005\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\131\001\000\000\000\000\000\000\000\000\000\000\133\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\135\002\000\000\000\000\000\000\000\000\
\000\000\000\000\014\000\183\004\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\181\001\000\000\035\002\000\000\000\000\
\000\000\000\000\123\001\000\000\000\000\063\007\000\000\000\000\
\000\000\000\000\000\255\000\000\000\000\135\007\032\005\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\202\007\012\008\078\008\144\008\000\000\133\001\133\001\211\008\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\115\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\063\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\034\255\008\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\137\002\000\000\000\000\000\000\
\237\014\000\000\000\000\000\000\000\000\000\000\000\000\026\000\
\000\000\024\000\010\000\000\000\000\000\000\000\000\000\145\002\
\000\000\000\000\000\000\255\002\000\000\109\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\088\001\
\142\005\000\000\000\000\000\000\000\000\058\000\000\000\000\000\
\213\255\000\000\000\000\000\000\000\000\000\000\009\255\000\000\
\000\000\000\000\024\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\019\000\151\000\
\090\001\017\000\000\000\000\000\028\012\215\004\069\012\000\000\
\000\000\166\010\233\010\023\009\089\009\155\009\123\001\000\000\
\222\009\032\010\000\000\043\011\109\011\217\011\000\000\000\001\
\000\000\080\255\000\000\089\000\000\000\000\000\000\000\000\000\
\000\000\000\000\084\001\000\000\000\000\000\000\237\014\183\000\
\000\000\142\000\000\000\142\000\000\000\008\000\000\000\000\000\
\000\000\000\000\000\000\000\000\066\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\042\000\000\000\
\000\000\000\000\000\000\063\000\000\000\000\000\000\000\000\000\
\149\002\000\000\132\001\000\000\219\003\000\000\073\004\000\000\
\100\010\000\000\000\000\102\000\000\000\000\000\252\005\149\001\
\000\000\000\000\149\001\088\001\248\255\000\000\205\255\149\001\
\088\001\244\001\167\255\000\000\000\000\017\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\181\015\000\000\000\000\000\000\000\000\000\000\098\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\101\006\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\018\000\000\000\000\000\000\000\096\001\
\152\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\073\001\000\000\000\000\000\000\000\000\000\000\
\000\000\075\001\000\000\000\000\000\000\000\000\000\000\000\000\
\066\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\014\000\014\000\014\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\211\006\
\000\000\000\000\155\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\127\002\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\013\000\157\001\000\000\
\000\000\000\000\000\000\000\000\000\000\008\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\063\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\008\000\000\000\000\000\
\000\000\000\000\000\000\024\000\010\000\010\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\075\001\000\000\000\000"

let yygindex = "\000\000\
\255\255\000\000\000\000\004\000\147\254\037\002\145\255\000\000\
\189\006\024\001\045\000\013\002\175\255\200\000\093\254\088\000\
\003\000\000\000\205\254\000\000\074\001\192\254\215\000\082\001\
\163\255\233\254\079\001\000\000\053\000\040\254\085\255\000\000\
\054\254\219\255\031\000\086\255\255\001\102\001\196\254\100\001\
\215\255\054\000\000\000\000\000\000\000\096\000\000\000\157\000\
\134\001\000\000\000\000\002\001\114\254\000\000\033\000\000\000\
\000\000\000\000\213\254\250\254\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\128\002\000\000\146\000\000\000\000\000\
\000\000\000\000\000\000\110\000\000\000\221\255\104\000\103\254\
\026\002\000\000\119\254\000\000\025\000\176\000\000\000\000\000\
\139\002\172\001\000\000"

let yytablesize = 4428
let yytable = "\037\000\
\100\001\167\000\178\001\018\002\171\000\099\000\162\001\164\001\
\081\001\194\000\090\001\109\000\017\002\181\000\097\000\162\000\
\069\000\167\001\068\000\182\000\206\001\184\000\186\000\186\000\
\209\001\189\000\214\001\125\000\205\001\005\000\138\000\069\001\
\221\001\097\000\210\001\031\002\130\000\142\000\239\000\052\001\
\252\001\179\000\239\000\196\001\162\000\045\002\166\000\115\001\
\163\000\166\000\143\001\149\000\104\000\104\000\111\000\016\002\
\178\000\191\001\192\001\075\002\239\000\095\002\181\000\085\000\
\075\001\046\001\089\002\111\000\111\000\111\000\111\000\192\000\
\097\000\081\000\050\000\139\001\111\000\225\001\104\000\076\002\
\155\000\168\001\198\001\085\000\166\000\080\002\139\000\005\000\
\133\000\134\000\135\000\136\000\097\000\164\000\102\000\105\000\
\105\000\239\000\169\000\012\001\183\000\133\000\134\000\135\000\
\136\000\119\002\137\000\253\001\070\001\071\001\138\000\101\001\
\102\001\103\001\104\001\105\001\106\001\107\001\108\001\137\000\
\197\001\105\000\164\000\138\000\156\000\157\000\192\000\114\001\
\112\000\117\001\154\001\119\001\120\001\121\001\122\001\123\001\
\124\001\125\001\126\001\127\001\072\001\073\001\074\001\166\001\
\162\001\164\001\057\002\154\002\087\001\092\001\067\000\031\002\
\085\002\135\001\111\002\112\002\113\002\113\000\061\001\199\001\
\065\002\144\001\024\002\012\001\148\001\068\002\139\000\140\000\
\141\000\138\000\114\000\099\000\090\002\005\000\005\000\166\000\
\166\000\157\001\162\000\139\000\140\000\141\000\163\000\110\002\
\095\002\065\001\128\001\064\002\135\000\078\001\115\000\099\000\
\067\002\129\001\111\000\111\000\111\000\111\000\111\000\025\002\
\111\000\111\000\111\000\111\000\151\002\111\000\142\000\005\000\
\138\000\091\002\098\000\091\001\150\001\135\000\116\000\236\000\
\102\000\146\001\147\001\118\001\149\000\099\000\160\001\079\001\
\079\001\139\000\236\000\141\000\156\002\098\000\099\000\062\001\
\117\000\138\000\063\001\064\001\168\002\091\000\175\001\080\001\
\081\001\203\001\146\002\118\000\102\000\152\000\024\002\153\000\
\154\000\155\000\099\000\120\002\171\002\123\002\124\002\079\000\
\164\000\079\001\066\001\116\002\117\002\067\001\068\001\182\001\
\139\000\140\000\141\000\184\001\098\000\186\001\176\000\078\001\
\092\000\241\000\254\001\119\000\091\000\241\000\069\000\090\002\
\068\000\255\001\069\000\172\002\068\000\069\000\165\000\068\000\
\098\000\139\000\244\000\141\000\208\001\156\000\157\000\241\000\
\091\000\069\000\238\000\068\000\174\002\211\001\069\000\069\000\
\120\000\069\000\005\000\179\001\166\000\216\001\091\001\092\000\
\166\000\157\001\166\000\126\000\182\002\079\001\177\000\083\000\
\069\000\080\001\068\000\037\002\081\001\194\000\081\001\244\000\
\069\000\181\000\068\000\092\000\241\000\069\000\204\001\068\000\
\069\000\238\000\068\000\186\000\204\001\189\000\080\001\053\001\
\054\001\070\000\127\000\069\000\238\000\068\000\218\001\212\001\
\222\001\162\001\164\001\169\000\069\000\179\000\068\000\217\001\
\160\001\005\000\048\001\084\000\127\001\179\000\179\000\070\002\
\235\001\083\000\240\001\181\000\129\000\012\002\181\000\181\000\
\181\000\111\000\181\000\055\001\014\002\090\001\015\002\189\000\
\186\000\186\000\189\000\189\000\034\002\131\000\087\001\092\001\
\162\001\164\001\092\001\132\000\090\001\219\001\118\000\179\000\
\185\000\179\000\179\000\179\000\179\000\002\000\177\002\178\002\
\002\000\233\001\234\001\004\002\067\000\084\000\172\000\173\000\
\067\000\118\000\166\000\067\000\181\000\049\001\118\000\181\000\
\181\000\174\000\051\001\243\001\022\002\060\001\175\000\067\000\
\076\001\166\000\077\001\086\001\143\000\096\001\097\001\109\000\
\105\000\044\002\098\001\109\000\001\000\002\000\003\000\133\000\
\134\000\135\000\136\000\116\001\149\001\105\000\067\000\151\001\
\152\001\153\001\109\000\159\001\169\000\169\001\067\000\109\000\
\081\002\137\000\204\001\067\000\082\002\138\000\067\000\204\001\
\173\001\174\001\189\001\176\001\146\001\020\002\181\001\134\002\
\183\001\067\000\187\001\200\001\072\002\073\002\224\001\236\001\
\237\001\109\000\067\000\239\001\242\001\109\000\098\002\138\000\
\245\001\078\002\046\002\072\000\247\001\249\001\248\001\000\002\
\102\002\103\002\104\002\250\001\160\001\166\000\001\002\160\001\
\002\002\166\000\010\002\011\002\160\001\079\000\013\002\087\001\
\026\002\079\000\035\002\036\002\079\000\139\000\140\000\141\000\
\073\000\038\002\039\002\041\002\047\002\042\002\087\001\020\002\
\079\000\043\002\048\002\166\000\051\002\052\002\178\000\049\002\
\053\002\054\002\147\000\055\002\056\002\066\002\108\002\074\002\
\077\002\137\002\079\002\083\002\087\002\088\002\146\001\086\002\
\142\002\093\002\092\002\094\002\166\000\097\002\084\002\079\000\
\107\002\160\001\105\002\255\001\079\000\099\002\115\002\079\000\
\080\001\150\002\160\001\042\000\121\002\122\002\125\002\126\002\
\132\002\133\002\079\000\127\002\128\002\129\002\135\002\141\002\
\136\002\145\002\144\002\079\000\004\002\004\002\166\000\053\000\
\054\000\055\000\056\000\147\002\057\000\166\000\148\002\070\000\
\160\001\074\000\155\002\070\000\169\000\169\000\070\000\152\002\
\153\002\149\002\092\001\092\001\165\002\157\002\173\002\058\000\
\158\002\159\002\070\000\227\001\166\002\170\002\167\002\070\000\
\070\000\070\000\070\000\175\002\180\002\183\002\078\000\083\000\
\140\001\162\002\186\002\001\000\209\000\184\002\018\001\084\000\
\025\001\070\000\003\000\133\000\134\000\135\000\136\000\083\000\
\148\000\070\000\020\002\213\000\217\000\003\001\070\000\167\000\
\160\001\070\000\103\000\166\000\014\001\137\000\010\001\232\000\
\104\000\138\000\112\000\113\001\070\000\246\001\160\001\136\001\
\181\002\071\002\220\001\213\001\215\001\070\000\161\002\169\002\
\165\001\069\002\166\000\202\001\207\001\143\000\140\002\101\002\
\040\002\143\000\143\000\185\001\176\002\160\001\143\000\047\001\
\143\000\143\000\118\002\139\002\143\002\146\001\070\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\172\001\
\106\002\187\002\143\000\143\000\143\000\143\000\050\001\000\000\
\177\001\139\000\140\000\141\000\000\000\027\002\028\002\055\000\
\056\000\029\002\057\000\000\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\000\000\000\000\000\000\
\000\000\143\000\000\000\000\000\143\000\030\002\000\000\000\000\
\000\000\072\000\000\000\000\000\000\000\072\000\149\000\143\000\
\072\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\143\000\000\000\000\000\000\000\072\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\073\000\143\000\
\143\000\000\000\073\000\000\000\000\000\073\000\000\000\000\000\
\143\000\143\000\143\000\147\000\143\000\143\000\000\000\147\000\
\147\000\073\000\000\000\072\000\147\000\000\000\147\000\147\000\
\072\000\000\000\000\000\072\000\000\000\147\000\147\000\147\000\
\147\000\147\000\147\000\147\000\147\000\000\000\072\000\000\000\
\147\000\147\000\147\000\147\000\000\000\000\000\000\000\072\000\
\073\000\000\000\000\000\000\000\000\000\073\000\000\000\000\000\
\073\000\000\000\147\000\147\000\147\000\147\000\147\000\147\000\
\147\000\147\000\147\000\073\000\000\000\000\000\000\000\147\000\
\000\000\000\000\147\000\000\000\073\000\000\000\000\000\074\000\
\000\000\000\000\000\000\074\000\153\000\147\000\074\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\147\000\000\000\
\000\000\000\000\074\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\078\000\147\000\147\000\000\000\
\078\000\000\000\000\000\078\000\000\000\000\000\147\000\147\000\
\147\000\148\000\147\000\147\000\000\000\148\000\148\000\078\000\
\000\000\074\000\148\000\000\000\148\000\148\000\074\000\000\000\
\000\000\074\000\000\000\148\000\148\000\148\000\148\000\148\000\
\148\000\148\000\148\000\000\000\074\000\000\000\148\000\148\000\
\148\000\148\000\000\000\000\000\000\000\074\000\078\000\000\000\
\000\000\000\000\000\000\078\000\228\001\000\000\078\000\000\000\
\148\000\148\000\148\000\148\000\148\000\148\000\148\000\148\000\
\148\000\078\000\000\000\000\000\000\000\148\000\000\000\000\000\
\148\000\000\000\078\000\000\000\133\000\134\000\135\000\136\000\
\000\000\000\000\154\000\148\000\000\000\000\000\000\000\229\001\
\000\000\000\000\000\000\000\000\148\000\000\000\137\000\000\000\
\000\000\000\000\138\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\148\000\148\000\000\000\000\000\133\000\
\134\000\135\000\136\000\000\000\148\000\148\000\148\000\149\000\
\148\000\148\000\000\000\149\000\149\000\000\000\000\000\000\000\
\149\000\137\000\149\000\149\000\000\000\138\000\000\000\000\000\
\000\000\149\000\149\000\149\000\149\000\149\000\149\000\149\000\
\149\000\000\000\000\000\000\000\149\000\149\000\149\000\149\000\
\000\000\000\000\139\000\140\000\141\000\000\000\000\000\000\000\
\000\000\232\001\000\000\000\000\000\000\000\000\149\000\149\000\
\149\000\149\000\149\000\149\000\149\000\149\000\149\000\000\000\
\000\000\000\000\000\000\149\000\000\000\000\000\149\000\000\000\
\000\000\133\000\134\000\135\000\136\000\139\000\140\000\141\000\
\155\000\149\000\000\000\000\000\000\000\238\001\000\000\000\000\
\000\000\000\000\149\000\137\000\000\000\000\000\000\000\138\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\149\000\149\000\000\000\000\000\133\000\134\000\135\000\
\136\000\000\000\149\000\149\000\149\000\153\000\149\000\149\000\
\000\000\153\000\153\000\000\000\000\000\000\000\153\000\137\000\
\153\000\153\000\000\000\138\000\000\000\000\000\000\000\153\000\
\153\000\153\000\153\000\153\000\153\000\153\000\153\000\000\000\
\000\000\000\000\153\000\153\000\153\000\153\000\000\000\139\000\
\140\000\141\000\000\000\000\000\000\000\000\000\000\000\241\001\
\000\000\000\000\000\000\000\000\153\000\153\000\153\000\153\000\
\153\000\153\000\153\000\153\000\153\000\000\000\000\000\000\000\
\000\000\153\000\000\000\000\000\153\000\000\000\000\000\133\000\
\134\000\135\000\136\000\139\000\140\000\141\000\165\000\153\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\153\000\137\000\000\000\000\000\000\000\138\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\
\153\000\000\000\000\000\000\000\000\000\000\000\071\000\000\000\
\153\000\153\000\153\000\154\000\153\000\153\000\000\000\154\000\
\154\000\000\000\000\000\000\000\154\000\000\000\154\000\154\000\
\000\000\000\000\000\000\000\000\000\000\154\000\154\000\154\000\
\154\000\154\000\154\000\154\000\154\000\000\000\000\000\000\000\
\154\000\154\000\154\000\154\000\000\000\139\000\140\000\141\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\130\002\000\000\154\000\154\000\154\000\154\000\154\000\154\000\
\154\000\154\000\154\000\000\000\000\000\000\000\000\000\154\000\
\000\000\000\000\154\000\000\000\000\000\000\000\000\000\043\000\
\133\000\134\000\135\000\136\000\000\000\154\000\000\000\000\000\
\000\000\179\002\000\000\000\000\000\000\000\000\154\000\000\000\
\000\000\000\000\137\000\000\000\000\000\000\000\138\000\000\000\
\000\000\000\000\000\000\000\000\000\000\154\000\154\000\000\000\
\000\000\133\000\134\000\135\000\136\000\000\000\154\000\154\000\
\154\000\155\000\154\000\154\000\142\000\155\000\155\000\000\000\
\000\000\000\000\155\000\137\000\155\000\155\000\000\000\138\000\
\000\000\000\000\149\000\155\000\155\000\155\000\155\000\155\000\
\155\000\155\000\155\000\000\000\000\000\000\000\155\000\155\000\
\155\000\155\000\000\000\000\000\000\000\000\000\139\000\140\000\
\141\000\150\000\151\000\152\000\000\000\153\000\154\000\155\000\
\155\000\155\000\155\000\155\000\155\000\155\000\155\000\155\000\
\155\000\000\000\000\000\000\000\000\000\155\000\000\000\000\000\
\155\000\000\000\000\000\000\000\000\000\121\000\000\000\139\000\
\140\000\141\000\000\000\155\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\155\000\000\000\000\000\000\000\
\000\000\000\000\000\000\156\000\157\000\000\000\000\000\000\000\
\000\000\000\000\000\000\155\000\155\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\155\000\155\000\155\000\165\000\
\155\000\155\000\000\000\165\000\165\000\000\000\000\000\000\000\
\165\000\000\000\165\000\165\000\000\000\000\000\000\000\000\000\
\000\000\000\000\165\000\165\000\165\000\165\000\165\000\165\000\
\165\000\000\000\000\000\000\000\165\000\165\000\165\000\165\000\
\000\000\000\000\000\000\000\000\071\000\000\000\000\000\000\000\
\071\000\000\000\000\000\071\000\000\000\000\000\165\000\165\000\
\165\000\165\000\165\000\165\000\165\000\165\000\165\000\071\000\
\084\000\000\000\000\000\165\000\071\000\071\000\165\000\071\000\
\000\000\000\000\000\000\123\000\085\000\086\000\087\000\088\000\
\000\000\165\000\000\000\000\000\000\000\000\000\071\000\000\000\
\000\000\000\000\165\000\000\000\000\000\000\000\071\000\000\000\
\000\000\000\000\000\000\071\000\000\000\000\000\071\000\000\000\
\000\000\165\000\165\000\000\000\000\000\000\000\000\000\000\000\
\000\000\071\000\165\000\165\000\165\000\043\000\165\000\165\000\
\000\000\043\000\071\000\043\000\043\000\000\000\000\000\000\000\
\000\000\000\000\043\000\043\000\043\000\043\000\043\000\043\000\
\043\000\043\000\000\000\000\000\000\000\043\000\043\000\043\000\
\043\000\000\000\000\000\071\000\089\000\090\000\091\000\092\000\
\093\000\094\000\095\000\096\000\097\000\098\000\000\000\043\000\
\043\000\043\000\043\000\043\000\043\000\043\000\043\000\043\000\
\000\000\000\000\000\000\000\000\043\000\000\000\000\000\043\000\
\223\001\000\000\000\000\000\000\042\000\133\000\134\000\135\000\
\136\000\000\000\043\000\133\000\134\000\135\000\136\000\000\000\
\000\000\000\000\000\000\043\000\000\000\000\000\000\000\137\000\
\000\000\000\000\000\000\138\000\000\000\137\000\000\000\000\000\
\000\000\138\000\043\000\043\000\000\000\000\000\000\000\000\000\
\000\000\000\000\109\001\043\000\043\000\043\000\121\000\043\000\
\043\000\000\000\000\000\121\000\000\000\000\000\000\000\121\000\
\000\000\121\000\121\000\133\000\134\000\135\000\136\000\000\000\
\121\000\121\000\121\000\121\000\121\000\121\000\121\000\121\000\
\000\000\000\000\000\000\121\000\121\000\121\000\121\000\000\000\
\000\000\138\000\000\000\139\000\140\000\141\000\000\000\000\000\
\000\000\139\000\140\000\110\001\000\000\121\000\121\000\121\000\
\121\000\121\000\121\000\121\000\000\000\121\000\110\000\000\000\
\000\000\000\000\121\000\000\000\000\000\121\000\000\000\000\000\
\000\000\000\000\130\000\121\000\122\000\123\000\124\000\000\000\
\121\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\
\000\000\121\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\139\000\140\000\141\000\000\000\000\000\000\000\000\000\
\121\000\121\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\121\000\121\000\121\000\123\000\121\000\121\000\000\000\
\000\000\123\000\000\000\000\000\000\000\123\000\000\000\123\000\
\123\000\000\000\000\000\000\000\000\000\000\000\123\000\123\000\
\123\000\123\000\123\000\123\000\123\000\123\000\000\000\000\000\
\000\000\123\000\123\000\123\000\123\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\123\000\123\000\123\000\123\000\123\000\
\123\000\123\000\005\000\123\000\084\000\000\000\091\001\000\000\
\123\000\000\000\000\000\123\000\000\000\000\000\118\000\000\000\
\085\000\086\000\087\000\088\000\000\000\000\000\123\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\123\000\
\000\000\000\000\130\001\131\001\132\001\133\001\134\001\000\000\
\137\001\138\001\140\001\141\001\000\000\142\001\123\000\123\000\
\000\000\000\000\000\000\000\000\079\001\000\000\000\000\123\000\
\123\000\123\000\042\000\123\000\123\000\000\000\042\000\000\000\
\042\000\042\000\000\000\000\000\000\000\000\000\000\000\042\000\
\042\000\042\000\042\000\042\000\042\000\042\000\042\000\000\000\
\000\000\000\000\042\000\042\000\042\000\042\000\009\000\000\000\
\089\000\090\000\091\000\092\000\093\000\094\000\095\000\096\000\
\097\000\098\000\000\000\000\000\042\000\042\000\042\000\042\000\
\042\000\042\000\042\000\042\000\042\000\000\000\000\000\000\000\
\000\000\042\000\226\001\000\000\042\000\000\000\000\000\133\000\
\134\000\135\000\136\000\230\001\000\000\000\000\000\000\042\000\
\133\000\134\000\135\000\136\000\000\000\000\000\000\000\000\000\
\042\000\137\000\000\000\000\000\000\000\138\000\000\000\000\000\
\000\000\000\000\137\000\000\000\000\000\000\000\138\000\042\000\
\042\000\027\000\000\000\133\000\134\000\135\000\136\000\000\000\
\042\000\042\000\042\000\130\000\042\000\042\000\000\000\000\000\
\130\000\000\000\000\000\000\000\130\000\137\000\130\000\130\000\
\000\000\138\000\000\000\000\000\000\000\130\000\130\000\130\000\
\130\000\130\000\130\000\130\000\130\000\114\002\000\000\000\000\
\130\000\130\000\130\000\130\000\000\000\139\000\140\000\141\000\
\000\000\000\000\000\000\000\000\000\000\000\000\139\000\140\000\
\141\000\000\000\130\000\130\000\130\000\130\000\130\000\130\000\
\130\000\201\001\130\000\028\000\000\000\000\000\000\000\130\000\
\000\000\000\000\130\000\000\000\000\000\000\000\000\000\000\000\
\000\000\139\000\140\000\141\000\000\000\130\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\130\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\130\000\130\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\130\000\130\000\
\130\000\000\000\130\000\130\000\118\000\000\000\000\000\000\000\
\118\000\000\000\118\000\118\000\000\000\030\000\000\000\000\000\
\000\000\118\000\118\000\118\000\118\000\118\000\118\000\118\000\
\118\000\000\000\000\000\142\000\118\000\118\000\118\000\118\000\
\000\000\000\000\143\000\144\000\145\000\146\000\147\000\148\000\
\000\000\149\000\000\000\000\000\000\000\000\000\118\000\118\000\
\118\000\000\000\118\000\118\000\118\000\000\000\118\000\000\000\
\000\000\000\000\000\000\118\000\000\000\000\000\118\000\000\000\
\150\000\151\000\152\000\000\000\153\000\154\000\155\000\000\000\
\000\000\118\000\000\000\000\000\009\000\000\000\000\000\031\000\
\009\000\000\000\118\000\009\000\000\000\000\000\000\000\000\000\
\000\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\000\000\118\000\118\000\000\000\009\000\009\000\009\000\009\000\
\000\000\000\000\118\000\118\000\118\000\000\000\118\000\118\000\
\000\000\000\000\156\000\157\000\000\000\000\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\000\000\009\000\158\000\
\159\000\000\000\000\000\009\000\000\000\000\000\009\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\000\
\000\000\009\000\029\000\027\000\000\000\000\000\027\000\000\000\
\000\000\000\000\009\000\000\000\027\000\027\000\027\000\027\000\
\027\000\027\000\027\000\000\000\000\000\000\000\000\000\027\000\
\027\000\027\000\027\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\009\000\009\000\009\000\000\000\009\000\009\000\
\000\000\027\000\027\000\027\000\027\000\027\000\027\000\027\000\
\000\000\027\000\000\000\000\000\000\000\000\000\027\000\000\000\
\000\000\027\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\028\000\000\000\000\000\027\000\028\000\020\000\000\000\
\028\000\000\000\000\000\000\000\000\000\027\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\000\000\000\000\000\000\
\000\000\028\000\028\000\028\000\028\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\027\000\027\000\027\000\
\000\000\027\000\027\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\000\000\028\000\000\000\000\000\000\000\000\000\
\028\000\000\000\000\000\028\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\030\000\000\000\000\000\028\000\030\000\
\021\000\000\000\030\000\000\000\000\000\000\000\000\000\028\000\
\030\000\030\000\030\000\030\000\030\000\030\000\030\000\000\000\
\000\000\000\000\000\000\030\000\030\000\030\000\030\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\000\
\028\000\028\000\000\000\028\000\028\000\030\000\030\000\030\000\
\030\000\030\000\030\000\030\000\000\000\030\000\000\000\000\000\
\000\000\000\000\030\000\000\000\000\000\030\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\031\000\000\000\000\000\
\030\000\031\000\022\000\000\000\031\000\000\000\000\000\000\000\
\000\000\030\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\000\000\000\000\000\000\000\000\031\000\031\000\031\000\
\031\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\030\000\030\000\030\000\000\000\030\000\030\000\031\000\
\031\000\031\000\031\000\031\000\031\000\031\000\000\000\031\000\
\000\000\000\000\000\000\000\000\031\000\000\000\000\000\031\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\029\000\000\000\031\000\000\000\029\000\049\000\000\000\029\000\
\000\000\000\000\000\000\031\000\000\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\000\000\000\000\000\000\000\000\
\029\000\029\000\029\000\029\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\031\000\031\000\031\000\000\000\031\000\
\031\000\000\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\000\000\029\000\000\000\000\000\000\000\000\000\029\000\
\000\000\000\000\029\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\020\000\029\000\000\000\051\000\
\020\000\000\000\000\000\020\000\000\000\000\000\029\000\000\000\
\000\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\000\000\000\000\000\000\000\000\020\000\020\000\020\000\020\000\
\000\000\000\000\000\000\000\000\000\000\000\000\029\000\029\000\
\029\000\000\000\029\000\029\000\000\000\000\000\020\000\020\000\
\020\000\020\000\020\000\020\000\020\000\000\000\020\000\000\000\
\000\000\000\000\000\000\020\000\000\000\000\000\020\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\021\000\000\000\
\000\000\020\000\021\000\048\000\000\000\021\000\000\000\000\000\
\000\000\000\000\020\000\021\000\021\000\021\000\021\000\021\000\
\021\000\021\000\000\000\000\000\000\000\000\000\021\000\021\000\
\021\000\021\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\020\000\020\000\020\000\000\000\020\000\020\000\
\021\000\021\000\021\000\021\000\021\000\021\000\021\000\000\000\
\021\000\000\000\000\000\000\000\000\000\021\000\000\000\000\000\
\021\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\022\000\000\000\000\000\021\000\022\000\019\000\000\000\022\000\
\000\000\000\000\000\000\000\000\021\000\022\000\022\000\022\000\
\022\000\022\000\022\000\022\000\000\000\000\000\000\000\000\000\
\022\000\022\000\022\000\022\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\021\000\021\000\021\000\000\000\
\021\000\021\000\022\000\022\000\022\000\022\000\022\000\022\000\
\022\000\000\000\022\000\000\000\000\000\000\000\000\000\022\000\
\000\000\000\000\022\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\049\000\000\000\022\000\000\000\049\000\
\018\000\000\000\049\000\000\000\000\000\000\000\022\000\000\000\
\049\000\049\000\049\000\049\000\049\000\049\000\049\000\000\000\
\000\000\000\000\000\000\049\000\049\000\049\000\049\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\022\000\022\000\
\022\000\000\000\022\000\022\000\000\000\049\000\049\000\049\000\
\049\000\049\000\049\000\049\000\000\000\049\000\000\000\000\000\
\000\000\000\000\049\000\000\000\000\000\049\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\051\000\000\000\000\000\
\049\000\051\000\044\000\000\000\051\000\000\000\000\000\000\000\
\000\000\049\000\051\000\051\000\051\000\051\000\051\000\051\000\
\051\000\000\000\000\000\000\000\000\000\051\000\051\000\051\000\
\051\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\049\000\049\000\049\000\000\000\049\000\049\000\051\000\
\051\000\051\000\051\000\051\000\051\000\051\000\000\000\051\000\
\000\000\000\000\000\000\000\000\051\000\000\000\000\000\051\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\048\000\051\000\000\000\045\000\048\000\000\000\000\000\
\048\000\000\000\000\000\051\000\000\000\000\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\000\000\000\000\000\000\
\000\000\048\000\048\000\048\000\048\000\000\000\000\000\000\000\
\000\000\000\000\000\000\051\000\051\000\051\000\000\000\051\000\
\051\000\000\000\000\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\000\000\048\000\000\000\000\000\000\000\000\000\
\048\000\000\000\000\000\048\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\019\000\000\000\000\000\048\000\019\000\
\007\000\000\000\019\000\000\000\000\000\000\000\000\000\048\000\
\019\000\019\000\019\000\019\000\019\000\019\000\019\000\000\000\
\000\000\000\000\000\000\019\000\019\000\019\000\019\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\048\000\
\048\000\048\000\000\000\048\000\048\000\019\000\019\000\019\000\
\081\000\019\000\000\000\000\000\000\000\019\000\000\000\000\000\
\000\000\000\000\019\000\000\000\000\000\019\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\018\000\000\000\
\019\000\000\000\018\000\000\000\000\000\018\000\000\000\000\000\
\000\000\019\000\000\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\000\000\000\000\000\000\000\000\018\000\018\000\
\018\000\018\000\000\000\000\000\000\000\133\000\134\000\135\000\
\136\000\019\000\019\000\019\000\000\000\019\000\019\000\000\000\
\018\000\018\000\018\000\077\000\018\000\000\000\000\000\137\000\
\018\000\000\000\000\000\138\000\000\000\018\000\000\000\244\001\
\018\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\044\000\000\000\000\000\018\000\044\000\000\000\000\000\044\000\
\000\000\000\000\000\000\000\000\018\000\044\000\044\000\044\000\
\044\000\044\000\044\000\044\000\076\000\000\000\000\000\000\000\
\044\000\044\000\044\000\044\000\000\000\000\000\000\000\133\000\
\134\000\135\000\136\000\000\000\018\000\018\000\018\000\000\000\
\018\000\018\000\044\000\139\000\140\000\141\000\044\000\000\000\
\000\000\137\000\044\000\000\000\000\000\138\000\000\000\044\000\
\000\000\000\000\044\000\000\000\000\000\000\000\000\000\000\000\
\000\000\185\002\045\000\000\000\000\000\044\000\045\000\000\000\
\000\000\045\000\000\000\000\000\000\000\000\000\044\000\045\000\
\045\000\045\000\045\000\045\000\045\000\045\000\000\000\000\000\
\000\000\000\000\045\000\045\000\045\000\045\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\044\000\044\000\
\044\000\000\000\044\000\044\000\045\000\139\000\140\000\141\000\
\045\000\000\000\000\000\000\000\045\000\000\000\000\000\000\000\
\000\000\045\000\231\001\000\000\045\000\000\000\000\000\133\000\
\134\000\135\000\136\000\000\000\000\000\000\000\007\000\045\000\
\000\000\000\000\007\000\000\000\000\000\007\000\000\000\000\000\
\045\000\137\000\000\000\000\000\000\000\138\000\000\000\000\000\
\000\000\007\000\000\000\000\000\000\000\000\000\007\000\007\000\
\007\000\007\000\000\000\000\000\000\000\000\000\000\000\000\000\
\045\000\045\000\045\000\000\000\045\000\045\000\081\000\000\000\
\007\000\000\000\081\000\000\000\007\000\081\000\000\000\000\000\
\007\000\000\000\000\000\000\000\000\000\007\000\000\000\000\000\
\007\000\081\000\000\000\000\000\000\000\000\000\081\000\081\000\
\081\000\081\000\000\000\007\000\000\000\139\000\140\000\141\000\
\000\000\000\000\000\000\000\000\007\000\000\000\000\000\000\000\
\081\000\000\000\000\000\000\000\081\000\000\000\000\000\000\000\
\081\000\000\000\000\000\000\000\000\000\081\000\000\000\000\000\
\081\000\000\000\000\000\000\000\007\000\007\000\007\000\000\000\
\000\000\077\000\000\000\081\000\000\000\077\000\000\000\000\000\
\077\000\000\000\000\000\000\000\081\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\077\000\000\000\000\000\000\000\
\000\000\077\000\077\000\077\000\077\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\081\000\081\000\081\000\000\000\
\000\000\000\000\076\000\077\000\000\000\000\000\076\000\000\000\
\005\000\076\000\084\000\077\000\000\000\000\000\000\000\000\000\
\077\000\000\000\000\000\077\000\000\000\076\000\085\000\086\000\
\087\000\088\000\076\000\076\000\076\000\076\000\077\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\077\000\
\000\000\000\000\000\000\000\000\076\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\076\000\000\000\000\000\000\000\
\000\000\076\000\000\000\000\000\076\000\000\000\000\000\077\000\
\077\000\077\000\000\000\000\000\000\000\000\000\000\000\076\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\076\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\089\000\090\000\
\091\000\092\000\093\000\094\000\095\000\096\000\097\000\098\000\
\000\000\076\000\076\000\187\000\188\000\189\000\190\000\191\000\
\192\000\193\000\194\000\195\000\196\000\197\000\198\000\199\000\
\200\000\201\000\202\000\203\000\204\000\205\000\206\000\207\000\
\208\000\209\000\210\000\211\000\212\000\213\000\214\000\215\000\
\216\000\217\000\218\000\219\000\220\000\221\000\222\000\223\000\
\224\000\225\000\226\000\227\000\228\000\229\000\230\000\231\000\
\232\000\233\000\234\000\235\000\236\000\237\000\238\000\239\000\
\240\000\241\000\242\000\243\000\244\000\245\000\246\000\247\000\
\248\000\249\000\250\000\251\000\252\000\253\000\254\000\255\000\
\000\001\001\001\002\001\000\000\003\001\004\001\005\001\006\001\
\007\001\000\000\000\000\008\001\009\001\010\001\011\001\012\001\
\000\000\013\001\014\001\015\001\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\005\000\000\000\084\000\006\000\007\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\085\000\086\000\
\087\000\088\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\008\000\009\000\000\000\000\000\000\000\
\000\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\000\000\131\002\
\023\000\024\000\025\000\026\000\133\000\134\000\135\000\136\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\027\000\028\000\000\000\000\000\000\000\000\000\137\000\000\000\
\000\000\000\000\138\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\029\000\000\000\000\000\000\000\089\000\090\000\
\091\000\092\000\093\000\094\000\095\000\096\000\097\000\098\000\
\030\000\031\000\000\000\000\000\000\000\000\000\000\000\005\000\
\000\000\084\000\006\000\007\000\000\000\000\000\032\000\000\000\
\000\000\033\000\034\000\035\000\036\000\085\000\086\000\087\000\
\088\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\139\000\140\000\141\000\000\000\000\000\000\000\
\010\000\011\000\012\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\000\000\000\000\023\000\
\024\000\025\000\026\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\027\000\
\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\029\000\000\000\000\000\000\000\089\000\090\000\091\000\
\092\000\093\000\094\000\095\000\096\000\097\000\098\000\030\000\
\031\000\005\000\000\000\000\000\006\000\007\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\032\000\000\000\000\000\
\033\000\000\000\035\000\036\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\008\000\009\000\000\000\000\000\
\000\000\000\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\000\000\
\000\000\023\000\024\000\025\000\026\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\027\000\028\000\000\000\000\000\000\000\000\000\003\002\
\000\000\133\000\134\000\135\000\136\000\000\000\133\000\134\000\
\135\000\136\000\000\000\029\000\000\000\005\000\000\000\000\000\
\006\000\007\000\000\000\137\000\000\000\000\000\000\000\138\000\
\137\000\030\000\031\000\000\000\138\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\032\000\
\008\000\009\000\033\000\034\000\035\000\036\000\010\000\011\000\
\012\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\000\000\163\002\023\000\024\000\025\000\
\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\027\000\028\000\139\000\
\140\000\141\000\000\000\138\002\139\000\140\000\141\000\000\000\
\000\000\133\000\134\000\135\000\136\000\000\000\000\000\029\000\
\000\000\005\000\000\000\000\000\006\000\007\000\000\000\000\000\
\000\000\000\000\000\000\137\000\000\000\030\000\031\000\138\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\032\000\008\000\009\000\033\000\034\000\
\035\000\036\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\164\002\
\000\000\023\000\024\000\025\000\026\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\027\000\028\000\000\000\000\000\000\000\000\000\139\000\
\140\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\029\000\000\000\001\000\000\000\000\000\
\001\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\030\000\031\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\032\000\
\001\000\001\000\033\000\034\000\035\000\036\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\000\000\000\000\001\000\001\000\001\000\
\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\001\000\001\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\
\000\000\005\000\000\000\000\000\006\000\007\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\001\000\001\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\001\000\000\000\000\000\001\000\001\000\
\001\000\001\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\000\000\
\000\000\023\000\024\000\025\000\026\000\041\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\027\000\028\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\029\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\030\000\031\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\042\000\043\000\032\000\
\044\000\045\000\033\000\046\000\035\000\036\000\000\000\047\000\
\048\000\049\000\050\000\000\000\051\000\052\000\000\000\000\000\
\043\000\053\000\054\000\055\000\056\000\000\000\057\000\043\000\
\043\000\043\000\043\000\043\000\043\000\000\000\043\000\000\000\
\000\000\000\000\043\000\043\000\043\000\043\000\000\000\000\000\
\000\000\058\000\059\000\000\000\000\000\060\000\000\000\061\000\
\000\000\000\000\000\000\000\000\043\000\043\000\043\000\000\000\
\043\000\043\000\043\000\043\000\005\000\000\000\084\000\000\000\
\000\000\043\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\160\002\085\000\086\000\087\000\088\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\043\000\
\043\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\043\000\043\000\043\000\000\000\043\000\043\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\089\000\090\000\091\000\092\000\093\000\094\000\
\095\000\096\000\097\000\098\000"

let yycheck = "\001\000\
\112\000\043\000\046\001\167\001\046\000\007\000\178\000\178\000\
\102\000\000\000\104\000\009\000\166\001\000\000\006\001\005\001\
\000\000\019\001\000\000\055\000\081\001\057\000\058\000\000\000\
\085\001\000\000\091\001\029\000\080\001\006\001\052\001\015\001\
\097\001\025\001\086\001\173\001\034\000\012\001\005\001\081\000\
\150\001\000\000\009\001\015\001\005\001\188\001\043\000\129\000\
\009\001\046\000\162\000\026\001\008\000\009\000\010\000\165\001\
\053\000\105\001\106\001\064\001\027\001\022\002\000\000\064\001\
\006\001\061\001\013\002\023\000\024\000\025\000\026\000\009\001\
\064\001\067\001\070\001\157\000\032\000\006\001\034\000\084\001\
\055\001\083\001\015\001\084\001\081\000\249\001\108\001\064\001\
\030\001\031\001\032\001\033\001\084\001\083\001\007\000\008\000\
\009\000\064\001\045\000\020\001\056\000\030\001\031\001\032\001\
\033\001\052\002\048\001\151\001\092\001\093\001\052\001\113\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\048\001\
\092\001\034\000\083\001\052\001\099\001\100\001\064\001\129\000\
\005\001\131\000\172\000\133\000\134\000\135\000\136\000\137\000\
\138\000\139\000\140\000\141\000\096\000\097\000\098\000\179\000\
\060\001\060\001\207\001\108\002\104\000\105\000\000\000\033\002\
\006\002\155\000\041\002\042\002\043\002\005\001\015\001\092\001\
\212\001\163\000\027\001\084\001\166\000\217\001\108\001\109\001\
\110\001\052\001\005\001\005\001\027\001\001\001\001\001\172\000\
\173\000\174\000\005\001\108\001\109\001\110\001\009\001\037\002\
\145\002\015\001\142\000\211\001\032\001\005\001\005\001\025\001\
\216\001\149\000\150\000\151\000\152\000\153\000\154\000\064\001\
\156\000\157\000\158\000\159\000\102\002\161\000\012\001\001\001\
\052\001\064\001\006\001\005\001\168\000\032\001\005\001\064\001\
\129\000\164\000\165\000\132\000\026\001\055\001\178\000\051\001\
\051\001\108\001\075\001\110\001\115\002\025\001\064\001\088\001\
\005\001\052\001\091\001\092\001\144\002\025\001\185\000\055\001\
\078\001\079\001\096\002\005\001\157\000\051\001\027\001\053\001\
\054\001\055\001\084\001\056\002\150\002\062\002\063\002\000\000\
\083\001\051\001\088\001\047\002\048\002\091\001\092\001\049\001\
\108\001\109\001\110\001\053\001\064\001\055\001\074\001\005\001\
\025\001\005\001\063\001\005\001\064\001\009\001\006\001\027\001\
\006\001\070\001\010\001\064\001\010\001\013\001\058\001\013\001\
\084\001\108\001\027\001\110\001\005\001\099\001\100\001\027\001\
\084\001\025\001\025\001\025\001\154\002\005\001\030\001\031\001\
\005\001\033\001\001\001\048\001\049\001\005\001\005\001\064\001\
\053\001\054\001\055\001\005\001\064\001\051\001\074\001\006\001\
\048\001\055\001\048\001\179\001\162\001\060\001\164\001\064\001\
\056\001\060\001\056\001\084\001\064\001\061\001\080\001\061\001\
\064\001\064\001\064\001\060\001\086\001\060\001\055\001\068\001\
\069\001\000\000\005\001\075\001\075\001\075\001\096\001\055\001\
\098\001\013\002\013\002\046\001\084\001\060\001\084\001\055\001\
\060\001\001\001\001\001\006\001\110\001\068\001\069\001\223\001\
\110\001\056\001\116\001\102\001\005\001\159\001\105\001\106\001\
\107\001\077\001\060\001\104\001\162\001\219\001\164\001\102\001\
\105\001\106\001\105\001\106\001\174\001\005\001\090\001\091\001\
\052\002\052\002\094\001\005\001\234\001\097\001\001\001\102\001\
\058\001\104\001\105\001\106\001\107\001\061\001\157\002\158\002\
\064\001\109\001\110\001\157\001\006\001\056\001\058\001\059\001\
\010\001\020\001\159\001\013\001\102\001\001\001\025\001\105\001\
\106\001\069\001\000\000\010\001\169\001\019\001\074\001\025\001\
\006\001\174\001\006\001\013\001\000\000\064\001\025\001\001\001\
\097\001\187\001\064\001\005\001\001\000\002\000\003\000\030\001\
\031\001\032\001\033\001\064\001\064\001\110\001\048\001\025\001\
\009\001\064\001\020\001\001\001\151\001\005\001\056\001\025\001\
\250\001\048\001\212\001\061\001\254\001\052\001\064\001\217\001\
\083\001\009\001\102\001\064\001\167\001\168\001\064\001\079\002\
\064\001\075\001\107\001\015\001\230\001\231\001\006\001\006\001\
\006\001\051\001\084\001\006\001\051\001\055\001\024\002\052\001\
\056\001\243\001\189\001\000\000\006\001\025\001\084\001\064\001\
\028\002\029\002\030\002\009\001\208\001\250\001\061\001\211\001\
\064\001\254\001\064\001\064\001\216\001\006\001\019\001\219\001\
\083\001\010\001\005\001\009\001\013\001\108\001\109\001\110\001\
\000\000\064\001\064\001\064\001\103\001\064\001\234\001\226\001\
\025\001\064\001\103\001\024\002\020\001\025\001\027\002\060\001\
\015\001\015\001\000\000\006\001\056\001\006\001\035\002\027\001\
\006\001\083\002\005\001\058\001\025\001\064\001\249\001\075\001\
\090\002\025\001\020\001\084\001\049\002\006\001\001\002\056\001\
\064\001\013\002\084\001\070\001\061\001\086\001\009\001\064\001\
\055\001\101\002\022\002\057\001\006\001\025\001\006\001\056\001\
\074\002\075\002\075\001\006\001\056\001\006\001\064\001\020\001\
\064\001\025\001\019\001\084\001\086\002\087\002\083\002\077\001\
\078\001\079\001\080\001\064\001\082\001\090\002\001\001\006\001\
\052\002\000\000\006\001\010\001\047\002\048\002\013\001\009\001\
\064\001\084\001\062\002\063\002\006\001\064\001\152\002\101\001\
\064\001\064\001\025\001\006\001\064\001\009\001\064\001\030\001\
\031\001\032\001\033\001\027\001\020\001\064\001\000\000\013\001\
\000\000\131\002\064\001\001\001\000\000\175\002\000\000\013\001\
\000\000\048\001\006\001\030\001\031\001\032\001\033\001\056\001\
\000\000\056\001\093\002\064\001\000\000\084\001\061\001\020\001\
\108\002\064\001\006\001\152\002\084\001\048\001\084\001\064\001\
\006\001\052\001\006\001\127\000\075\001\142\001\122\002\155\000\
\170\002\226\001\097\001\090\001\094\001\084\001\122\002\145\002\
\178\000\219\001\175\002\078\001\081\001\001\001\087\002\027\002\
\183\001\005\001\006\001\054\001\156\002\145\002\010\001\064\000\
\012\001\013\001\049\002\086\002\093\002\144\002\109\001\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\182\000\
\033\002\185\002\030\001\031\001\032\001\033\001\076\000\255\255\
\045\001\108\001\109\001\110\001\255\255\077\001\078\001\079\001\
\080\001\081\001\082\001\255\255\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\061\001\255\255\255\255\064\001\101\001\255\255\255\255\
\255\255\006\001\255\255\255\255\255\255\010\001\000\000\075\001\
\013\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\084\001\255\255\255\255\255\255\025\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\006\001\099\001\
\100\001\255\255\010\001\255\255\255\255\013\001\255\255\255\255\
\108\001\109\001\110\001\001\001\112\001\113\001\255\255\005\001\
\006\001\025\001\255\255\056\001\010\001\255\255\012\001\013\001\
\061\001\255\255\255\255\064\001\255\255\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\255\255\075\001\255\255\
\030\001\031\001\032\001\033\001\255\255\255\255\255\255\084\001\
\056\001\255\255\255\255\255\255\255\255\061\001\255\255\255\255\
\064\001\255\255\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\075\001\255\255\255\255\255\255\061\001\
\255\255\255\255\064\001\255\255\084\001\255\255\255\255\006\001\
\255\255\255\255\255\255\010\001\000\000\075\001\013\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\084\001\255\255\
\255\255\255\255\025\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\006\001\099\001\100\001\255\255\
\010\001\255\255\255\255\013\001\255\255\255\255\108\001\109\001\
\110\001\001\001\112\001\113\001\255\255\005\001\006\001\025\001\
\255\255\056\001\010\001\255\255\012\001\013\001\061\001\255\255\
\255\255\064\001\255\255\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\255\255\075\001\255\255\030\001\031\001\
\032\001\033\001\255\255\255\255\255\255\084\001\056\001\255\255\
\255\255\255\255\255\255\061\001\006\001\255\255\064\001\255\255\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\075\001\255\255\255\255\255\255\061\001\255\255\255\255\
\064\001\255\255\084\001\255\255\030\001\031\001\032\001\033\001\
\255\255\255\255\000\000\075\001\255\255\255\255\255\255\006\001\
\255\255\255\255\255\255\255\255\084\001\255\255\048\001\255\255\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\100\001\255\255\255\255\030\001\
\031\001\032\001\033\001\255\255\108\001\109\001\110\001\001\001\
\112\001\113\001\255\255\005\001\006\001\255\255\255\255\255\255\
\010\001\048\001\012\001\013\001\255\255\052\001\255\255\255\255\
\255\255\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\026\001\255\255\255\255\255\255\030\001\031\001\032\001\033\001\
\255\255\255\255\108\001\109\001\110\001\255\255\255\255\255\255\
\255\255\006\001\255\255\255\255\255\255\255\255\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\061\001\255\255\255\255\064\001\255\255\
\255\255\030\001\031\001\032\001\033\001\108\001\109\001\110\001\
\000\000\075\001\255\255\255\255\255\255\006\001\255\255\255\255\
\255\255\255\255\084\001\048\001\255\255\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\100\001\255\255\255\255\030\001\031\001\032\001\
\033\001\255\255\108\001\109\001\110\001\001\001\112\001\113\001\
\255\255\005\001\006\001\255\255\255\255\255\255\010\001\048\001\
\012\001\013\001\255\255\052\001\255\255\255\255\255\255\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\255\255\
\255\255\255\255\030\001\031\001\032\001\033\001\255\255\108\001\
\109\001\110\001\255\255\255\255\255\255\255\255\255\255\006\001\
\255\255\255\255\255\255\255\255\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\061\001\255\255\255\255\064\001\255\255\255\255\030\001\
\031\001\032\001\033\001\108\001\109\001\110\001\000\000\075\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\084\001\048\001\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\100\001\255\255\255\255\255\255\255\255\255\255\000\000\255\255\
\108\001\109\001\110\001\001\001\112\001\113\001\255\255\005\001\
\006\001\255\255\255\255\255\255\010\001\255\255\012\001\013\001\
\255\255\255\255\255\255\255\255\255\255\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\255\255\255\255\255\255\
\030\001\031\001\032\001\033\001\255\255\108\001\109\001\110\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\006\001\255\255\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\061\001\
\255\255\255\255\064\001\255\255\255\255\255\255\255\255\000\000\
\030\001\031\001\032\001\033\001\255\255\075\001\255\255\255\255\
\255\255\006\001\255\255\255\255\255\255\255\255\084\001\255\255\
\255\255\255\255\048\001\255\255\255\255\255\255\052\001\255\255\
\255\255\255\255\255\255\255\255\255\255\099\001\100\001\255\255\
\255\255\030\001\031\001\032\001\033\001\255\255\108\001\109\001\
\110\001\001\001\112\001\113\001\012\001\005\001\006\001\255\255\
\255\255\255\255\010\001\048\001\012\001\013\001\255\255\052\001\
\255\255\255\255\026\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\255\255\255\255\255\255\030\001\031\001\
\032\001\033\001\255\255\255\255\255\255\255\255\108\001\109\001\
\110\001\049\001\050\001\051\001\255\255\053\001\054\001\055\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\061\001\255\255\255\255\
\064\001\255\255\255\255\255\255\255\255\000\000\255\255\108\001\
\109\001\110\001\255\255\075\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\084\001\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\100\001\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\100\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\108\001\109\001\110\001\001\001\
\112\001\113\001\255\255\005\001\006\001\255\255\255\255\255\255\
\010\001\255\255\012\001\013\001\255\255\255\255\255\255\255\255\
\255\255\255\255\020\001\021\001\022\001\023\001\024\001\025\001\
\026\001\255\255\255\255\255\255\030\001\031\001\032\001\033\001\
\255\255\255\255\255\255\255\255\006\001\255\255\255\255\255\255\
\010\001\255\255\255\255\013\001\255\255\255\255\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\025\001\
\003\001\255\255\255\255\061\001\030\001\031\001\064\001\033\001\
\255\255\255\255\255\255\000\000\015\001\016\001\017\001\018\001\
\255\255\075\001\255\255\255\255\255\255\255\255\048\001\255\255\
\255\255\255\255\084\001\255\255\255\255\255\255\056\001\255\255\
\255\255\255\255\255\255\061\001\255\255\255\255\064\001\255\255\
\255\255\099\001\100\001\255\255\255\255\255\255\255\255\255\255\
\255\255\075\001\108\001\109\001\110\001\006\001\112\001\113\001\
\255\255\010\001\084\001\012\001\013\001\255\255\255\255\255\255\
\255\255\255\255\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\026\001\255\255\255\255\255\255\030\001\031\001\032\001\
\033\001\255\255\255\255\109\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\255\255\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\255\255\061\001\255\255\255\255\064\001\
\025\001\255\255\255\255\255\255\000\000\030\001\031\001\032\001\
\033\001\255\255\075\001\030\001\031\001\032\001\033\001\255\255\
\255\255\255\255\255\255\084\001\255\255\255\255\255\255\048\001\
\255\255\255\255\255\255\052\001\255\255\048\001\255\255\255\255\
\255\255\052\001\099\001\100\001\255\255\255\255\255\255\255\255\
\255\255\255\255\061\001\108\001\109\001\110\001\001\001\112\001\
\113\001\255\255\255\255\006\001\255\255\255\255\255\255\010\001\
\255\255\012\001\013\001\030\001\031\001\032\001\033\001\255\255\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\026\001\
\255\255\255\255\255\255\030\001\031\001\032\001\033\001\255\255\
\255\255\052\001\255\255\108\001\109\001\110\001\255\255\255\255\
\255\255\108\001\109\001\110\001\255\255\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\255\255\056\001\010\000\255\255\
\255\255\255\255\061\001\255\255\255\255\064\001\255\255\255\255\
\255\255\255\255\000\000\023\000\024\000\025\000\026\000\255\255\
\075\001\255\255\255\255\255\255\032\000\255\255\255\255\255\255\
\255\255\084\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\109\001\110\001\255\255\255\255\255\255\255\255\
\099\001\100\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\109\001\110\001\001\001\112\001\113\001\255\255\
\255\255\006\001\255\255\255\255\255\255\010\001\255\255\012\001\
\013\001\255\255\255\255\255\255\255\255\255\255\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\255\255\255\255\
\255\255\030\001\031\001\032\001\033\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\001\001\056\001\003\001\255\255\005\001\255\255\
\061\001\255\255\255\255\064\001\255\255\255\255\000\000\255\255\
\015\001\016\001\017\001\018\001\255\255\255\255\075\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\084\001\
\255\255\255\255\150\000\151\000\152\000\153\000\154\000\255\255\
\156\000\157\000\158\000\159\000\255\255\161\000\099\001\100\001\
\255\255\255\255\255\255\255\255\051\001\255\255\255\255\108\001\
\109\001\110\001\006\001\112\001\113\001\255\255\010\001\255\255\
\012\001\013\001\255\255\255\255\255\255\255\255\255\255\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\255\255\
\255\255\255\255\030\001\031\001\032\001\033\001\000\000\255\255\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\255\255\255\255\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\255\255\255\255\255\255\
\255\255\061\001\025\001\255\255\064\001\255\255\255\255\030\001\
\031\001\032\001\033\001\025\001\255\255\255\255\255\255\075\001\
\030\001\031\001\032\001\033\001\255\255\255\255\255\255\255\255\
\084\001\048\001\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\048\001\255\255\255\255\255\255\052\001\099\001\
\100\001\000\000\255\255\030\001\031\001\032\001\033\001\255\255\
\108\001\109\001\110\001\001\001\112\001\113\001\255\255\255\255\
\006\001\255\255\255\255\255\255\010\001\048\001\012\001\013\001\
\255\255\052\001\255\255\255\255\255\255\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\064\001\255\255\255\255\
\030\001\031\001\032\001\033\001\255\255\108\001\109\001\110\001\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\109\001\
\110\001\255\255\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\077\001\056\001\000\000\255\255\255\255\255\255\061\001\
\255\255\255\255\064\001\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\109\001\110\001\255\255\075\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\084\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\099\001\100\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\109\001\
\110\001\255\255\112\001\113\001\006\001\255\255\255\255\255\255\
\010\001\255\255\012\001\013\001\255\255\000\000\255\255\255\255\
\255\255\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\026\001\255\255\255\255\012\001\030\001\031\001\032\001\033\001\
\255\255\255\255\019\001\020\001\021\001\022\001\023\001\024\001\
\255\255\026\001\255\255\255\255\255\255\255\255\048\001\049\001\
\050\001\255\255\052\001\053\001\054\001\255\255\056\001\255\255\
\255\255\255\255\255\255\061\001\255\255\255\255\064\001\255\255\
\049\001\050\001\051\001\255\255\053\001\054\001\055\001\255\255\
\255\255\075\001\255\255\255\255\006\001\255\255\255\255\000\000\
\010\001\255\255\084\001\013\001\255\255\255\255\255\255\255\255\
\255\255\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\255\255\099\001\100\001\255\255\030\001\031\001\032\001\033\001\
\255\255\255\255\108\001\109\001\110\001\255\255\112\001\113\001\
\255\255\255\255\099\001\100\001\255\255\255\255\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\255\255\056\001\112\001\
\113\001\255\255\255\255\061\001\255\255\255\255\064\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\006\001\
\255\255\075\001\000\000\010\001\255\255\255\255\013\001\255\255\
\255\255\255\255\084\001\255\255\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\255\255\255\255\255\255\255\255\030\001\
\031\001\032\001\033\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\108\001\109\001\110\001\255\255\112\001\113\001\
\255\255\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\255\255\056\001\255\255\255\255\255\255\255\255\061\001\255\255\
\255\255\064\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\006\001\255\255\255\255\075\001\010\001\000\000\255\255\
\013\001\255\255\255\255\255\255\255\255\084\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\255\255\255\255\255\255\
\255\255\030\001\031\001\032\001\033\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\108\001\109\001\110\001\
\255\255\112\001\113\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\255\255\056\001\255\255\255\255\255\255\255\255\
\061\001\255\255\255\255\064\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\006\001\255\255\255\255\075\001\010\001\
\000\000\255\255\013\001\255\255\255\255\255\255\255\255\084\001\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\255\255\
\255\255\255\255\255\255\030\001\031\001\032\001\033\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\108\001\
\109\001\110\001\255\255\112\001\113\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\255\255\056\001\255\255\255\255\
\255\255\255\255\061\001\255\255\255\255\064\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\006\001\255\255\255\255\
\075\001\010\001\000\000\255\255\013\001\255\255\255\255\255\255\
\255\255\084\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\255\255\255\255\255\255\255\255\030\001\031\001\032\001\
\033\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\109\001\110\001\255\255\112\001\113\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\255\255\056\001\
\255\255\255\255\255\255\255\255\061\001\255\255\255\255\064\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\006\001\255\255\075\001\255\255\010\001\000\000\255\255\013\001\
\255\255\255\255\255\255\084\001\255\255\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\255\255\255\255\255\255\255\255\
\030\001\031\001\032\001\033\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\108\001\109\001\110\001\255\255\112\001\
\113\001\255\255\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\255\255\056\001\255\255\255\255\255\255\255\255\061\001\
\255\255\255\255\064\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\006\001\075\001\255\255\000\000\
\010\001\255\255\255\255\013\001\255\255\255\255\084\001\255\255\
\255\255\019\001\020\001\021\001\022\001\023\001\024\001\025\001\
\255\255\255\255\255\255\255\255\030\001\031\001\032\001\033\001\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\109\001\
\110\001\255\255\112\001\113\001\255\255\255\255\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\255\255\056\001\255\255\
\255\255\255\255\255\255\061\001\255\255\255\255\064\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\006\001\255\255\
\255\255\075\001\010\001\000\000\255\255\013\001\255\255\255\255\
\255\255\255\255\084\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\255\255\255\255\255\255\255\255\030\001\031\001\
\032\001\033\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\108\001\109\001\110\001\255\255\112\001\113\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\255\255\
\056\001\255\255\255\255\255\255\255\255\061\001\255\255\255\255\
\064\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\006\001\255\255\255\255\075\001\010\001\000\000\255\255\013\001\
\255\255\255\255\255\255\255\255\084\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\255\255\255\255\255\255\255\255\
\030\001\031\001\032\001\033\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\108\001\109\001\110\001\255\255\
\112\001\113\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\255\255\056\001\255\255\255\255\255\255\255\255\061\001\
\255\255\255\255\064\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\006\001\255\255\075\001\255\255\010\001\
\000\000\255\255\013\001\255\255\255\255\255\255\084\001\255\255\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\255\255\
\255\255\255\255\255\255\030\001\031\001\032\001\033\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\109\001\
\110\001\255\255\112\001\113\001\255\255\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\255\255\056\001\255\255\255\255\
\255\255\255\255\061\001\255\255\255\255\064\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\006\001\255\255\255\255\
\075\001\010\001\000\000\255\255\013\001\255\255\255\255\255\255\
\255\255\084\001\019\001\020\001\021\001\022\001\023\001\024\001\
\025\001\255\255\255\255\255\255\255\255\030\001\031\001\032\001\
\033\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\109\001\110\001\255\255\112\001\113\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\255\255\056\001\
\255\255\255\255\255\255\255\255\061\001\255\255\255\255\064\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\006\001\075\001\255\255\000\000\010\001\255\255\255\255\
\013\001\255\255\255\255\084\001\255\255\255\255\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\255\255\255\255\255\255\
\255\255\030\001\031\001\032\001\033\001\255\255\255\255\255\255\
\255\255\255\255\255\255\108\001\109\001\110\001\255\255\112\001\
\113\001\255\255\255\255\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\255\255\056\001\255\255\255\255\255\255\255\255\
\061\001\255\255\255\255\064\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\006\001\255\255\255\255\075\001\010\001\
\000\000\255\255\013\001\255\255\255\255\255\255\255\255\084\001\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\255\255\
\255\255\255\255\255\255\030\001\031\001\032\001\033\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\108\001\
\109\001\110\001\255\255\112\001\113\001\048\001\049\001\050\001\
\000\000\052\001\255\255\255\255\255\255\056\001\255\255\255\255\
\255\255\255\255\061\001\255\255\255\255\064\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\006\001\255\255\
\075\001\255\255\010\001\255\255\255\255\013\001\255\255\255\255\
\255\255\084\001\255\255\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\255\255\255\255\255\255\255\255\030\001\031\001\
\032\001\033\001\255\255\255\255\255\255\030\001\031\001\032\001\
\033\001\108\001\109\001\110\001\255\255\112\001\113\001\255\255\
\048\001\049\001\050\001\000\000\052\001\255\255\255\255\048\001\
\056\001\255\255\255\255\052\001\255\255\061\001\255\255\056\001\
\064\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\006\001\255\255\255\255\075\001\010\001\255\255\255\255\013\001\
\255\255\255\255\255\255\255\255\084\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\000\000\255\255\255\255\255\255\
\030\001\031\001\032\001\033\001\255\255\255\255\255\255\030\001\
\031\001\032\001\033\001\255\255\108\001\109\001\110\001\255\255\
\112\001\113\001\048\001\108\001\109\001\110\001\052\001\255\255\
\255\255\048\001\056\001\255\255\255\255\052\001\255\255\061\001\
\255\255\255\255\064\001\255\255\255\255\255\255\255\255\255\255\
\255\255\064\001\006\001\255\255\255\255\075\001\010\001\255\255\
\255\255\013\001\255\255\255\255\255\255\255\255\084\001\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\255\255\255\255\
\255\255\255\255\030\001\031\001\032\001\033\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\108\001\109\001\
\110\001\255\255\112\001\113\001\048\001\108\001\109\001\110\001\
\052\001\255\255\255\255\255\255\056\001\255\255\255\255\255\255\
\255\255\061\001\025\001\255\255\064\001\255\255\255\255\030\001\
\031\001\032\001\033\001\255\255\255\255\255\255\006\001\075\001\
\255\255\255\255\010\001\255\255\255\255\013\001\255\255\255\255\
\084\001\048\001\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\025\001\255\255\255\255\255\255\255\255\030\001\031\001\
\032\001\033\001\255\255\255\255\255\255\255\255\255\255\255\255\
\108\001\109\001\110\001\255\255\112\001\113\001\006\001\255\255\
\048\001\255\255\010\001\255\255\052\001\013\001\255\255\255\255\
\056\001\255\255\255\255\255\255\255\255\061\001\255\255\255\255\
\064\001\025\001\255\255\255\255\255\255\255\255\030\001\031\001\
\032\001\033\001\255\255\075\001\255\255\108\001\109\001\110\001\
\255\255\255\255\255\255\255\255\084\001\255\255\255\255\255\255\
\048\001\255\255\255\255\255\255\052\001\255\255\255\255\255\255\
\056\001\255\255\255\255\255\255\255\255\061\001\255\255\255\255\
\064\001\255\255\255\255\255\255\108\001\109\001\110\001\255\255\
\255\255\006\001\255\255\075\001\255\255\010\001\255\255\255\255\
\013\001\255\255\255\255\255\255\084\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\025\001\255\255\255\255\255\255\
\255\255\030\001\031\001\032\001\033\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\108\001\109\001\110\001\255\255\
\255\255\255\255\006\001\048\001\255\255\255\255\010\001\255\255\
\001\001\013\001\003\001\056\001\255\255\255\255\255\255\255\255\
\061\001\255\255\255\255\064\001\255\255\025\001\015\001\016\001\
\017\001\018\001\030\001\031\001\032\001\033\001\075\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\084\001\
\255\255\255\255\255\255\255\255\048\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\056\001\255\255\255\255\255\255\
\255\255\061\001\255\255\255\255\064\001\255\255\255\255\108\001\
\109\001\110\001\255\255\255\255\255\255\255\255\255\255\075\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\084\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\255\255\109\001\110\001\001\001\002\001\003\001\004\001\005\001\
\006\001\007\001\008\001\009\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\255\255\074\001\075\001\076\001\077\001\
\078\001\255\255\255\255\081\001\082\001\083\001\084\001\085\001\
\255\255\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\095\001\096\001\097\001\098\001\099\001\100\001\101\001\
\102\001\103\001\104\001\105\001\106\001\107\001\108\001\109\001\
\110\001\111\001\112\001\113\001\114\001\115\001\116\001\117\001\
\001\001\255\255\003\001\004\001\005\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\015\001\016\001\
\017\001\018\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\028\001\029\001\255\255\255\255\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\255\255\025\001\
\049\001\050\001\051\001\052\001\030\001\031\001\032\001\033\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\065\001\066\001\255\255\255\255\255\255\255\255\048\001\255\255\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\083\001\255\255\255\255\255\255\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\097\001\098\001\255\255\255\255\255\255\255\255\255\255\001\001\
\255\255\003\001\004\001\005\001\255\255\255\255\111\001\255\255\
\255\255\114\001\115\001\116\001\117\001\015\001\016\001\017\001\
\018\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\108\001\109\001\110\001\255\255\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\255\255\255\255\049\001\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\065\001\
\066\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\083\001\255\255\255\255\255\255\087\001\088\001\089\001\
\090\001\091\001\092\001\093\001\094\001\095\001\096\001\097\001\
\098\001\001\001\255\255\255\255\004\001\005\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\111\001\255\255\255\255\
\114\001\255\255\116\001\117\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\028\001\029\001\255\255\255\255\
\255\255\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\255\255\
\255\255\049\001\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\065\001\066\001\255\255\255\255\255\255\255\255\071\001\
\255\255\030\001\031\001\032\001\033\001\255\255\030\001\031\001\
\032\001\033\001\255\255\083\001\255\255\001\001\255\255\255\255\
\004\001\005\001\255\255\048\001\255\255\255\255\255\255\052\001\
\048\001\097\001\098\001\255\255\052\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\111\001\
\028\001\029\001\114\001\115\001\116\001\117\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\255\255\084\001\049\001\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\065\001\066\001\108\001\
\109\001\110\001\255\255\071\001\108\001\109\001\110\001\255\255\
\255\255\030\001\031\001\032\001\033\001\255\255\255\255\083\001\
\255\255\001\001\255\255\255\255\004\001\005\001\255\255\255\255\
\255\255\255\255\255\255\048\001\255\255\097\001\098\001\052\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\111\001\028\001\029\001\114\001\115\001\
\116\001\117\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\084\001\
\255\255\049\001\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\065\001\066\001\255\255\255\255\255\255\255\255\108\001\
\109\001\110\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\083\001\255\255\001\001\255\255\255\255\
\004\001\005\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\098\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\111\001\
\028\001\029\001\114\001\115\001\116\001\117\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\255\255\255\255\049\001\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\065\001\066\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\083\001\
\255\255\001\001\255\255\255\255\004\001\005\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\097\001\098\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\111\001\255\255\255\255\114\001\115\001\
\116\001\117\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\255\255\
\255\255\049\001\050\001\051\001\052\001\001\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\065\001\066\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\083\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\098\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\111\001\
\060\001\061\001\114\001\063\001\116\001\117\001\255\255\067\001\
\068\001\069\001\070\001\255\255\072\001\073\001\255\255\255\255\
\012\001\077\001\078\001\079\001\080\001\255\255\082\001\019\001\
\020\001\021\001\022\001\023\001\024\001\255\255\026\001\255\255\
\255\255\255\255\030\001\031\001\032\001\033\001\255\255\255\255\
\255\255\101\001\102\001\255\255\255\255\105\001\255\255\107\001\
\255\255\255\255\255\255\255\255\048\001\049\001\050\001\255\255\
\052\001\053\001\054\001\055\001\001\001\255\255\003\001\255\255\
\255\255\061\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\014\001\015\001\016\001\017\001\018\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\100\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\108\001\109\001\110\001\255\255\112\001\113\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001"

let yynames_const = "\
  LPAR\000\
  RPAR\000\
  IF\000\
  ELSE\000\
  COLON\000\
  COLON2\000\
  COLONCOLON\000\
  DOT\000\
  DOTDOT\000\
  DOTDOTDOT\000\
  INT\000\
  INTEGER\000\
  REAL\000\
  FLOAT\000\
  LT\000\
  GT\000\
  LE\000\
  GE\000\
  EQ\000\
  NE\000\
  COMMA\000\
  ARROW\000\
  EQUAL\000\
  FORALL\000\
  EXISTS\000\
  IFF\000\
  IMPLIES\000\
  AND\000\
  OR\000\
  NOT\000\
  SEPARATED\000\
  TRUE\000\
  FALSE\000\
  OLD\000\
  AT\000\
  RESULT\000\
  BLOCK_LENGTH\000\
  BASE_ADDR\000\
  VALID\000\
  VALID_INDEX\000\
  VALID_RANGE\000\
  FRESH\000\
  DOLLAR\000\
  QUESTION\000\
  MINUS\000\
  PLUS\000\
  STAR\000\
  AMP\000\
  SLASH\000\
  PERCENT\000\
  LSQUARE\000\
  RSQUARE\000\
  EOF\000\
  GLOBAL\000\
  INVARIANT\000\
  VARIANT\000\
  DECREASES\000\
  FOR\000\
  LABEL\000\
  ASSERT\000\
  SEMICOLON\000\
  NULL\000\
  EMPTY\000\
  REQUIRES\000\
  ENSURES\000\
  ASSIGNS\000\
  LOOP\000\
  NOTHING\000\
  SLICE\000\
  IMPACT\000\
  PRAGMA\000\
  FROM\000\
  READS\000\
  LOGIC\000\
  PREDICATE\000\
  INDUCTIVE\000\
  AXIOMATIC\000\
  AXIOM\000\
  LEMMA\000\
  LBRACE\000\
  RBRACE\000\
  GHOST\000\
  CASE\000\
  VOID\000\
  CHAR\000\
  SIGNED\000\
  UNSIGNED\000\
  SHORT\000\
  LONG\000\
  DOUBLE\000\
  STRUCT\000\
  ENUM\000\
  UNION\000\
  BSUNION\000\
  INTER\000\
  LTCOLON\000\
  COLONGT\000\
  TYPE\000\
  BEHAVIOR\000\
  BEHAVIORS\000\
  ASSUMES\000\
  COMPLETE\000\
  DISJOINT\000\
  TERMINATES\000\
  HAT\000\
  HATHAT\000\
  PIPE\000\
  TILDE\000\
  GTGT\000\
  LTLT\000\
  SIZEOF\000\
  LAMBDA\000\
  TYPEOF\000\
  BSTYPE\000\
  "

let yynames_block = "\
  IDENTIFIER\000\
  STRING_LITERAL\000\
  TYPENAME\000\
  CONSTANT\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    Obj.repr(
# 106 "cil/src/logic/logic_parser.mly"
            ( enter_kw_c_mode () )
# 1917 "cil/src/logic/logic_parser.ml"
               : 'enter_kw_c_mode))
; (fun __caml_parser_env ->
    Obj.repr(
# 109 "cil/src/logic/logic_parser.mly"
            ( exit_kw_c_mode () )
# 1923 "cil/src/logic/logic_parser.ml"
               : 'exit_kw_c_mode))
; (fun __caml_parser_env ->
    Obj.repr(
# 115 "cil/src/logic/logic_parser.mly"
                ( [] )
# 1929 "cil/src/logic/logic_parser.ml"
               : 'lexpr_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ne_lexpr_list) in
    Obj.repr(
# 116 "cil/src/logic/logic_parser.mly"
                 ( _1 )
# 1936 "cil/src/logic/logic_parser.ml"
               : 'lexpr_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 120 "cil/src/logic/logic_parser.mly"
                           ( [_1] )
# 1943 "cil/src/logic/logic_parser.ml"
               : 'ne_lexpr_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ne_lexpr_list) in
    Obj.repr(
# 121 "cil/src/logic/logic_parser.mly"
                            ( _1 :: _3 )
# 1951 "cil/src/logic/logic_parser.ml"
               : 'ne_lexpr_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 125 "cil/src/logic/logic_parser.mly"
                                ( _1 )
# 1958 "cil/src/logic/logic_parser.ml"
               : 'lexpr_rel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_inner) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'rel_list) in
    Obj.repr(
# 127 "cil/src/logic/logic_parser.mly"
      ( let rel, rhs, _, oth_rel = _2 in
        let loc = loc_start _1, loc_end rhs in
        let relation = loc_info loc (PLrel(_1,rel,rhs)) in
        match oth_rel with
            None -> relation
          | Some oth_relation -> info (PLand(relation,oth_relation))
      )
# 1972 "cil/src/logic/logic_parser.ml"
               : 'lexpr_rel))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 136 "cil/src/logic/logic_parser.mly"
                    ( info (PLnot _2) )
# 1979 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    Obj.repr(
# 137 "cil/src/logic/logic_parser.mly"
         ( info PLtrue )
# 1985 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    Obj.repr(
# 138 "cil/src/logic/logic_parser.mly"
          ( info PLfalse )
# 1991 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 139 "cil/src/logic/logic_parser.mly"
                          ( info (PLvalid (_3)) )
# 1998 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Logic_ptree.lexpr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 140 "cil/src/logic/logic_parser.mly"
                                            ( info (PLvalid_index (_3,_5)) )
# 2006 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Logic_ptree.lexpr) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Logic_ptree.lexpr) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 142 "cil/src/logic/logic_parser.mly"
      ( info (PLvalid_range (_3,_5,_7)) )
# 2015 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 143 "cil/src/logic/logic_parser.mly"
                          ( info (PLfresh (_3)) )
# 2022 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    Obj.repr(
# 144 "cil/src/logic/logic_parser.mly"
         ( info PLnull )
# 2028 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.constant) in
    Obj.repr(
# 145 "cil/src/logic/logic_parser.mly"
             ( info (PLconstant _1) )
# 2035 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 146 "cil/src/logic/logic_parser.mly"
                                 ( info (PLbinop (_1, Badd, _3)) )
# 2043 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 147 "cil/src/logic/logic_parser.mly"
                                  ( info (PLbinop (_1, Bsub, _3)) )
# 2051 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 148 "cil/src/logic/logic_parser.mly"
                                 ( info (PLbinop (_1, Bmul, _3)) )
# 2059 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 149 "cil/src/logic/logic_parser.mly"
                                  ( info (PLbinop (_1, Bdiv, _3)) )
# 2067 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 150 "cil/src/logic/logic_parser.mly"
                                    ( info (PLbinop (_1, Bmod, _3)) )
# 2075 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 151 "cil/src/logic/logic_parser.mly"
                                 ( info (PLarrow (_1, _3)) )
# 2083 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 152 "cil/src/logic/logic_parser.mly"
                               ( info (PLdot (_1, _3)) )
# 2091 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'range) in
    Obj.repr(
# 153 "cil/src/logic/logic_parser.mly"
                                      ( info (PLarrget (_1, _3)) )
# 2099 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 154 "cil/src/logic/logic_parser.mly"
                                      ( info (PLarrget (_1, _3)) )
# 2107 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 155 "cil/src/logic/logic_parser.mly"
                                        ( info (PLunop (Uminus, _2)) )
# 2114 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 156 "cil/src/logic/logic_parser.mly"
                                       ( _2 )
# 2121 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 157 "cil/src/logic/logic_parser.mly"
                      ( info (PLunop (Ubw_not, _2)) )
# 2128 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 158 "cil/src/logic/logic_parser.mly"
                     ( info (PLunop (Ustar, _2)) )
# 2135 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 159 "cil/src/logic/logic_parser.mly"
                    ( info (PLunop (Uamp, _2)) )
# 2142 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 160 "cil/src/logic/logic_parser.mly"
                           ( info (PLsizeofE _3) )
# 2149 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'logic_type_not_id) in
    Obj.repr(
# 161 "cil/src/logic/logic_parser.mly"
                                       ( info (PLsizeof _3) )
# 2156 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 162 "cil/src/logic/logic_parser.mly"
                        ( info (PLold _3) )
# 2163 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Logic_ptree.lexpr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'label) in
    Obj.repr(
# 163 "cil/src/logic/logic_parser.mly"
                                   ( info (PLat (_3, _5)) )
# 2171 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 164 "cil/src/logic/logic_parser.mly"
                              ( info (PLbase_addr _3) )
# 2178 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 165 "cil/src/logic/logic_parser.mly"
                                 ( info (PLblock_length _3) )
# 2185 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    Obj.repr(
# 166 "cil/src/logic/logic_parser.mly"
           ( info PLresult )
# 2191 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_lexpr_list) in
    Obj.repr(
# 168 "cil/src/logic/logic_parser.mly"
      ( info (PLapp (_1, [], _3)) )
# 2199 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_lexpr_list) in
    Obj.repr(
# 170 "cil/src/logic/logic_parser.mly"
      ( info (PLseparated _3) )
# 2206 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'ne_tvar_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'ne_lexpr_list) in
    Obj.repr(
# 172 "cil/src/logic/logic_parser.mly"
      ( info (PLapp (_1, _3, _6)) )
# 2215 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_tvar_list) in
    Obj.repr(
# 174 "cil/src/logic/logic_parser.mly"
      ( info (PLapp (_1, _3, [])) )
# 2223 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 175 "cil/src/logic/logic_parser.mly"
                                ( info (PLvar _1) )
# 2230 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 176 "cil/src/logic/logic_parser.mly"
                                 ( info (PLbinop (_1, Brshift, _3)))
# 2238 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 177 "cil/src/logic/logic_parser.mly"
                                 ( info (PLbinop (_1, Blshift, _3)))
# 2246 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 178 "cil/src/logic/logic_parser.mly"
                                   ( info _2.lexpr_node )
# 2253 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'range) in
    Obj.repr(
# 179 "cil/src/logic/logic_parser.mly"
                    ( info _2.lexpr_node )
# 2260 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'logic_type_not_id) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 181 "cil/src/logic/logic_parser.mly"
      ( info (PLcast (_2, _4)) )
# 2268 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 183 "cil/src/logic/logic_parser.mly"
      ( info (PLsubtype (_1, _3)) )
# 2276 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'logic_type_not_id) in
    Obj.repr(
# 185 "cil/src/logic/logic_parser.mly"
      ( info (PLcoercion (_1, _3)) )
# 2284 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 187 "cil/src/logic/logic_parser.mly"
      ( info (PLcoercionE (_1, _3)) )
# 2292 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 188 "cil/src/logic/logic_parser.mly"
                           ( info (PLtypeof _3) )
# 2299 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'type_spec_not_id) in
    Obj.repr(
# 189 "cil/src/logic/logic_parser.mly"
                                           ( info (PLtype _3) )
# 2306 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    Obj.repr(
# 191 "cil/src/logic/logic_parser.mly"
          ( info PLempty )
# 2312 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_list) in
    Obj.repr(
# 192 "cil/src/logic/logic_parser.mly"
                                 ( info (PLunion _3) )
# 2319 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_list) in
    Obj.repr(
# 193 "cil/src/logic/logic_parser.mly"
                               ( info (PLinter _3) )
# 2326 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Logic_ptree.lexpr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'binders) in
    Obj.repr(
# 195 "cil/src/logic/logic_parser.mly"
      (info (PLcomprehension (_2,_4,None)) )
# 2334 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Logic_ptree.lexpr) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'binders) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 197 "cil/src/logic/logic_parser.mly"
      ( info (PLcomprehension (_2,_4,Some _6)) )
# 2343 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Logic_ptree.lexpr) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 199 "cil/src/logic/logic_parser.mly"
                                                   ( info (PLupdate(_2,_4,_6)) )
# 2352 "cil/src/logic/logic_parser.ml"
               : 'lexpr_inner))
; (fun __caml_parser_env ->
    Obj.repr(
# 203 "cil/src/logic/logic_parser.mly"
          ( Lt )
# 2358 "cil/src/logic/logic_parser.ml"
               : 'relation))
; (fun __caml_parser_env ->
    Obj.repr(
# 204 "cil/src/logic/logic_parser.mly"
          ( Gt )
# 2364 "cil/src/logic/logic_parser.ml"
               : 'relation))
; (fun __caml_parser_env ->
    Obj.repr(
# 205 "cil/src/logic/logic_parser.mly"
          ( Le )
# 2370 "cil/src/logic/logic_parser.ml"
               : 'relation))
; (fun __caml_parser_env ->
    Obj.repr(
# 206 "cil/src/logic/logic_parser.mly"
          ( Ge )
# 2376 "cil/src/logic/logic_parser.ml"
               : 'relation))
; (fun __caml_parser_env ->
    Obj.repr(
# 207 "cil/src/logic/logic_parser.mly"
          ( Eq )
# 2382 "cil/src/logic/logic_parser.ml"
               : 'relation))
; (fun __caml_parser_env ->
    Obj.repr(
# 208 "cil/src/logic/logic_parser.mly"
          ( Neq )
# 2388 "cil/src/logic/logic_parser.ml"
               : 'relation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_option) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_option) in
    Obj.repr(
# 212 "cil/src/logic/logic_parser.mly"
                                   ( info (PLrange(_1,_3)) )
# 2396 "cil/src/logic/logic_parser.ml"
               : 'range))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 216 "cil/src/logic/logic_parser.mly"
                      ( info (PLimplies (_1, _3)) )
# 2404 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 217 "cil/src/logic/logic_parser.mly"
                  ( info (PLiff (_1, _3)) )
# 2412 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 218 "cil/src/logic/logic_parser.mly"
                     ( info (PLor (_1, _3)) )
# 2420 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 219 "cil/src/logic/logic_parser.mly"
                     ( info (PLand (_1, _3)) )
# 2428 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 220 "cil/src/logic/logic_parser.mly"
                        ( info (PLxor (_1, _3)) )
# 2436 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'binders) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 222 "cil/src/logic/logic_parser.mly"
      ( info (PLforall (_2, _4)) )
# 2444 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'binders) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 224 "cil/src/logic/logic_parser.mly"
      ( info (PLexists (_2, _4)) )
# 2452 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'binders) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 226 "cil/src/logic/logic_parser.mly"
      ( info (PLlambda (_2,_4)) )
# 2460 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 228 "cil/src/logic/logic_parser.mly"
                  ( info (PLbinop (_1, Bbw_and, _3)) )
# 2468 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 229 "cil/src/logic/logic_parser.mly"
                   ( info (PLbinop (_1, Bbw_or, _3)) )
# 2476 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 230 "cil/src/logic/logic_parser.mly"
                  ( info (PLbinop (_1, Bbw_xor, _3)) )
# 2484 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 232 "cil/src/logic/logic_parser.mly"
    ( info (PLif (_1, _3, _5)) )
# 2493 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 234 "cil/src/logic/logic_parser.mly"
                                          ( info (PLnamed (_1, _3)) )
# 2501 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_rel) in
    Obj.repr(
# 235 "cil/src/logic/logic_parser.mly"
                                ( _1 )
# 2508 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'relation) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'lexpr_inner) in
    Obj.repr(
# 240 "cil/src/logic/logic_parser.mly"
  ( _1, _2, fst(relation_sense _1 Unknown), None )
# 2516 "cil/src/logic/logic_parser.ml"
               : 'rel_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'relation) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_inner) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'rel_list) in
    Obj.repr(
# 242 "cil/src/logic/logic_parser.mly"
  (
    let next_rel, rhs, sense, oth_rel = _3 in
    let (sense, correct) = relation_sense _1 sense
    in
    if correct then
      let loc = loc_start _2, loc_end rhs in
      let my_rel = loc_info loc (PLrel(_2,next_rel,rhs)) in
      let oth_rel = match oth_rel with
          None -> my_rel
        | Some rel ->
	    let loc = loc_start _2, loc_end rel in
	    loc_info loc (PLand(my_rel,rel))
      in
      _1,_2,sense,Some oth_rel
    else begin
      let loc = Parsing.rhs_start_pos 1, Parsing.rhs_end_pos 3 in
      raise (Not_well_formed
               (loc,"Inconsistent relation chain."));

    end
  )
# 2545 "cil/src/logic/logic_parser.ml"
               : 'rel_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 266 "cil/src/logic/logic_parser.mly"
                ( None )
# 2551 "cil/src/logic/logic_parser.ml"
               : 'lexpr_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 267 "cil/src/logic/logic_parser.mly"
                ( Some _1 )
# 2558 "cil/src/logic/logic_parser.ml"
               : 'lexpr_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'binders_reentrance) in
    Obj.repr(
# 272 "cil/src/logic/logic_parser.mly"
                            ( let (_lt, vars) = _1 in vars )
# 2565 "cil/src/logic/logic_parser.ml"
               : 'binders))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 276 "cil/src/logic/logic_parser.mly"
    ( let (lt, var) = _1 in (lt, [var])
    )
# 2573 "cil/src/logic/logic_parser.ml"
               : 'binders_reentrance))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'binders_reentrance) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 279 "cil/src/logic/logic_parser.mly"
    ( let _, vars = _1 in
      let (lt, var) = _3 in
        (lt, vars @ [ var ])
    )
# 2584 "cil/src/logic/logic_parser.ml"
               : 'binders_reentrance))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'binders_reentrance) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec) in
    Obj.repr(
# 284 "cil/src/logic/logic_parser.mly"
    ( let last_type_spec, vars = _1 in
        (last_type_spec, vars @ [ let (modif, name) = _3 in (modif last_type_spec, name)])
    )
# 2594 "cil/src/logic/logic_parser.ml"
               : 'binders_reentrance))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec_for_id) in
    Obj.repr(
# 291 "cil/src/logic/logic_parser.mly"
   ( let last_type_spec = LTnamed(_1, []) in
       (last_type_spec, let (modif, name) = _2 in [ (modif last_type_spec, name)])
   )
# 2604 "cil/src/logic/logic_parser.ml"
               : 'binders_reentrance))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'binders_reentrance) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec_for_id) in
    Obj.repr(
# 298 "cil/src/logic/logic_parser.mly"
   ( let _, vars = _1 in
     let last_type_spec = LTnamed(_3, []) in
       (last_type_spec, vars @ let (modif, name) = _4 in [ (modif last_type_spec, name)])
   )
# 2616 "cil/src/logic/logic_parser.ml"
               : 'binders_reentrance))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec_bis_for_id) in
    Obj.repr(
# 307 "cil/src/logic/logic_parser.mly"
                                     ( _1 )
# 2623 "cil/src/logic/logic_parser.ml"
               : 'var_spec_for_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stars) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec_bis_for_id) in
    Obj.repr(
# 309 "cil/src/logic/logic_parser.mly"
  ( let (modif, name) = _2 in
      ((fun x -> _1 (modif x)), name) )
# 2632 "cil/src/logic/logic_parser.ml"
               : 'var_spec_for_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 317 "cil/src/logic/logic_parser.mly"
                 ( ((fun x -> x), _1) )
# 2639 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis_for_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'var_spec_bis_for_id) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_option) in
    Obj.repr(
# 319 "cil/src/logic/logic_parser.mly"
      ( (* TODO: use size information for LTarray - $3 *)
        let (modif, name) = _1 in
          ((fun x -> LTarray (modif x)), name)
      )
# 2650 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis_for_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'var_spec_bis_for_id) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'abs_param_type_list) in
    Obj.repr(
# 323 "cil/src/logic/logic_parser.mly"
                                                    ( (* TODO *) raise Parse_error )
# 2658 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis_for_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec_not_id) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec) in
    Obj.repr(
# 327 "cil/src/logic/logic_parser.mly"
                            ( (_1, let (modif, name) = _2 in (modif _1, name))  )
# 2666 "cil/src/logic/logic_parser.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec_bis) in
    Obj.repr(
# 331 "cil/src/logic/logic_parser.mly"
                     ( _1 )
# 2673 "cil/src/logic/logic_parser.ml"
               : 'var_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stars) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec_bis) in
    Obj.repr(
# 333 "cil/src/logic/logic_parser.mly"
  ( let (modif, name) = _2 in
      ((fun x -> _1 (modif x)), name) )
# 2682 "cil/src/logic/logic_parser.ml"
               : 'var_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 338 "cil/src/logic/logic_parser.mly"
                 ( ((fun x -> x), _1) )
# 2689 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'var_spec_bis) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_option) in
    Obj.repr(
# 340 "cil/src/logic/logic_parser.mly"
      ( (* TODO: use size information for LTarray - $3 *)
        let (modif, name) = _1 in
          ((fun x -> LTarray (modif x)), name)
      )
# 2700 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'var_spec) in
    Obj.repr(
# 344 "cil/src/logic/logic_parser.mly"
                     ( _2 )
# 2707 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'var_spec_bis) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'abs_param_type_list) in
    Obj.repr(
# 345 "cil/src/logic/logic_parser.mly"
                                             ( (* TODO *) raise Parse_error )
# 2715 "cil/src/logic/logic_parser.ml"
               : 'var_spec_bis))
; (fun __caml_parser_env ->
    Obj.repr(
# 349 "cil/src/logic/logic_parser.mly"
              ( [ ] )
# 2721 "cil/src/logic/logic_parser.ml"
               : 'abs_param_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abs_param_list) in
    Obj.repr(
# 350 "cil/src/logic/logic_parser.mly"
                 ( _1 )
# 2728 "cil/src/logic/logic_parser.ml"
               : 'abs_param_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'abs_param_list) in
    Obj.repr(
# 351 "cil/src/logic/logic_parser.mly"
                                 ( (* TODO *) raise Parse_error )
# 2735 "cil/src/logic/logic_parser.ml"
               : 'abs_param_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abs_param) in
    Obj.repr(
# 355 "cil/src/logic/logic_parser.mly"
            ( [ _1 ] )
# 2742 "cil/src/logic/logic_parser.ml"
               : 'abs_param_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'abs_param_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'abs_param) in
    Obj.repr(
# 356 "cil/src/logic/logic_parser.mly"
                                 ( _1 @ [ _3 ] )
# 2750 "cil/src/logic/logic_parser.ml"
               : 'abs_param_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter) in
    Obj.repr(
# 363 "cil/src/logic/logic_parser.mly"
            ( _1 )
# 2757 "cil/src/logic/logic_parser.ml"
               : 'abs_param))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 369 "cil/src/logic/logic_parser.mly"
              ( LTnamed(_1, []) )
# 2764 "cil/src/logic/logic_parser.ml"
               : 'id_as_typename))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_logic_type_list) in
    Obj.repr(
# 374 "cil/src/logic/logic_parser.mly"
  ( LTnamed(_1, _3) )
# 2772 "cil/src/logic/logic_parser.ml"
               : 'id_as_typename_poly))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec_not_id) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abs_spec_option) in
    Obj.repr(
# 380 "cil/src/logic/logic_parser.mly"
                                    ( _2 _1 )
# 2780 "cil/src/logic/logic_parser.ml"
               : 'logic_type_not_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter) in
    Obj.repr(
# 384 "cil/src/logic/logic_parser.mly"
            ( [_1] )
# 2787 "cil/src/logic/logic_parser.ml"
               : 'ne_parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ne_parameters) in
    Obj.repr(
# 385 "cil/src/logic/logic_parser.mly"
                                ( _1 :: _3 )
# 2795 "cil/src/logic/logic_parser.ml"
               : 'ne_parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec) in
    Obj.repr(
# 389 "cil/src/logic/logic_parser.mly"
                     ( let (modif, name) = _2 in (modif _1, name))
# 2803 "cil/src/logic/logic_parser.ml"
               : 'parameter))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'id_as_typename) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'var_spec) in
    Obj.repr(
# 390 "cil/src/logic/logic_parser.mly"
                          ( let (modif, name) = _2 in (modif _1, name) )
# 2811 "cil/src/logic/logic_parser.ml"
               : 'parameter))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abs_spec_option) in
    Obj.repr(
# 397 "cil/src/logic/logic_parser.mly"
                             ( _2 _1 )
# 2819 "cil/src/logic/logic_parser.ml"
               : 'logic_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'id_as_typename) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abs_spec_option) in
    Obj.repr(
# 398 "cil/src/logic/logic_parser.mly"
                                 ( _2 _1 )
# 2827 "cil/src/logic/logic_parser.ml"
               : 'logic_type))
; (fun __caml_parser_env ->
    Obj.repr(
# 402 "cil/src/logic/logic_parser.mly"
                              ( fun t -> t )
# 2833 "cil/src/logic/logic_parser.ml"
               : 'abs_spec_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abs_spec) in
    Obj.repr(
# 403 "cil/src/logic/logic_parser.mly"
           ( _1 )
# 2840 "cil/src/logic/logic_parser.ml"
               : 'abs_spec_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tabs) in
    Obj.repr(
# 407 "cil/src/logic/logic_parser.mly"
                          ( _1 )
# 2847 "cil/src/logic/logic_parser.ml"
               : 'abs_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stars) in
    Obj.repr(
# 408 "cil/src/logic/logic_parser.mly"
                                         ( _1 )
# 2854 "cil/src/logic/logic_parser.ml"
               : 'abs_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stars) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tabs) in
    Obj.repr(
# 409 "cil/src/logic/logic_parser.mly"
                                         ( fun t -> _2 (_1 t) )
# 2862 "cil/src/logic/logic_parser.ml"
               : 'abs_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stars) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abs_spec_bis) in
    Obj.repr(
# 410 "cil/src/logic/logic_parser.mly"
                                         ( fun t -> _2 (_1 t) )
# 2870 "cil/src/logic/logic_parser.ml"
               : 'abs_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'stars) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abs_spec_bis) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tabs) in
    Obj.repr(
# 411 "cil/src/logic/logic_parser.mly"
                                         ( fun t -> _2 (_3 (_1 t)) )
# 2879 "cil/src/logic/logic_parser.ml"
               : 'abs_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'abs_spec_bis) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tabs) in
    Obj.repr(
# 412 "cil/src/logic/logic_parser.mly"
                                         ( fun t -> _1 (_2 t) )
# 2887 "cil/src/logic/logic_parser.ml"
               : 'abs_spec))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abs_spec) in
    Obj.repr(
# 416 "cil/src/logic/logic_parser.mly"
                     ( _2 )
# 2894 "cil/src/logic/logic_parser.ml"
               : 'abs_spec_bis))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'abs_spec_bis) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'abs_param_type_list) in
    Obj.repr(
# 417 "cil/src/logic/logic_parser.mly"
                                             ( (* TODO *) raise Parse_error )
# 2902 "cil/src/logic/logic_parser.ml"
               : 'abs_spec_bis))
; (fun __caml_parser_env ->
    Obj.repr(
# 421 "cil/src/logic/logic_parser.mly"
             ( fun t -> LTpointer t )
# 2908 "cil/src/logic/logic_parser.ml"
               : 'stars))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stars) in
    Obj.repr(
# 422 "cil/src/logic/logic_parser.mly"
             ( fun t -> _2 (LTpointer t) )
# 2915 "cil/src/logic/logic_parser.ml"
               : 'stars))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'lexpr_option) in
    Obj.repr(
# 427 "cil/src/logic/logic_parser.mly"
    (  (* TODO: use size information for LTarray - $2 *)
      fun t -> LTarray t
    )
# 2924 "cil/src/logic/logic_parser.ml"
               : 'tabs))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'lexpr_option) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tabs) in
    Obj.repr(
# 431 "cil/src/logic/logic_parser.mly"
    (  (* TODO: use size information for LTarray - $2 *)
      fun t -> LTarray (_4 t)
    )
# 2934 "cil/src/logic/logic_parser.ml"
               : 'tabs))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec_not_id) in
    Obj.repr(
# 437 "cil/src/logic/logic_parser.mly"
                   ( _1 )
# 2941 "cil/src/logic/logic_parser.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'id_as_typename_poly) in
    Obj.repr(
# 438 "cil/src/logic/logic_parser.mly"
                      ( _1 )
# 2948 "cil/src/logic/logic_parser.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 442 "cil/src/logic/logic_parser.mly"
                 ( LTinteger )
# 2954 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 443 "cil/src/logic/logic_parser.mly"
                 ( LTreal )
# 2960 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 444 "cil/src/logic/logic_parser.mly"
                 ( LTvoid )
# 2966 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 445 "cil/src/logic/logic_parser.mly"
                 ( LTint IChar )
# 2972 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 446 "cil/src/logic/logic_parser.mly"
                 ( LTint ISChar )
# 2978 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 447 "cil/src/logic/logic_parser.mly"
                 ( LTint IUChar )
# 2984 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 448 "cil/src/logic/logic_parser.mly"
                 ( LTint IInt )
# 2990 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 449 "cil/src/logic/logic_parser.mly"
                 ( LTint IInt )
# 2996 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 450 "cil/src/logic/logic_parser.mly"
                 ( LTint IUInt )
# 3002 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 451 "cil/src/logic/logic_parser.mly"
                 ( LTint IUInt )
# 3008 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 452 "cil/src/logic/logic_parser.mly"
                 ( LTint IShort )
# 3014 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 453 "cil/src/logic/logic_parser.mly"
                 ( LTint IShort )
# 3020 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 454 "cil/src/logic/logic_parser.mly"
                 ( LTint IUShort )
# 3026 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 455 "cil/src/logic/logic_parser.mly"
                 ( LTint ILong )
# 3032 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 456 "cil/src/logic/logic_parser.mly"
                 ( LTint ILong )
# 3038 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 457 "cil/src/logic/logic_parser.mly"
                 ( LTint IULong )
# 3044 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 458 "cil/src/logic/logic_parser.mly"
                 ( LTint ILong )
# 3050 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 459 "cil/src/logic/logic_parser.mly"
                 ( LTint ILong )
# 3056 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 460 "cil/src/logic/logic_parser.mly"
                    ( LTint IULong )
# 3062 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 461 "cil/src/logic/logic_parser.mly"
                 ( LTint ILongLong )
# 3068 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 463 "cil/src/logic/logic_parser.mly"
                     ( LTint ILongLong )
# 3074 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 465 "cil/src/logic/logic_parser.mly"
                     ( LTint IULongLong )
# 3080 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 467 "cil/src/logic/logic_parser.mly"
                    ( LTint ILongLong )
# 3086 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 469 "cil/src/logic/logic_parser.mly"
                        ( LTint ILongLong )
# 3092 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 471 "cil/src/logic/logic_parser.mly"
                         ( LTint IULongLong )
# 3098 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 473 "cil/src/logic/logic_parser.mly"
                    ( LTfloat FFloat )
# 3104 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 474 "cil/src/logic/logic_parser.mly"
                    ( LTfloat FDouble )
# 3110 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    Obj.repr(
# 475 "cil/src/logic/logic_parser.mly"
                    ( LTfloat FLongDouble )
# 3116 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 476 "cil/src/logic/logic_parser.mly"
                    ( LTstruct _2 )
# 3123 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 477 "cil/src/logic/logic_parser.mly"
                    ( LTenum _2 )
# 3130 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 478 "cil/src/logic/logic_parser.mly"
                    ( LTunion _2 )
# 3137 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 479 "cil/src/logic/logic_parser.mly"
                    ( LTnamed (_1,[]) )
# 3144 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_logic_type_list) in
    Obj.repr(
# 480 "cil/src/logic/logic_parser.mly"
                                    ( LTnamed(_1,_3) )
# 3152 "cil/src/logic/logic_parser.ml"
               : 'type_spec_not_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'logic_type) in
    Obj.repr(
# 484 "cil/src/logic/logic_parser.mly"
                                      ( [_1] )
# 3159 "cil/src/logic/logic_parser.ml"
               : 'ne_logic_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'logic_type) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ne_logic_type_list) in
    Obj.repr(
# 485 "cil/src/logic/logic_parser.mly"
                                      ( _1 :: _3 )
# 3167 "cil/src/logic/logic_parser.ml"
               : 'ne_logic_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 491 "cil/src/logic/logic_parser.mly"
                                     ( _2 )
# 3176 "cil/src/logic/logic_parser.ml"
               : 'full_lexpr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 495 "cil/src/logic/logic_parser.mly"
                                          ( _2 )
# 3185 "cil/src/logic/logic_parser.ml"
               : 'full_identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'ne_parameters) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 499 "cil/src/logic/logic_parser.mly"
                                             ( _2 )
# 3194 "cil/src/logic/logic_parser.ml"
               : 'full_parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 503 "cil/src/logic/logic_parser.mly"
                                         ( _2 )
# 3203 "cil/src/logic/logic_parser.ml"
               : 'full_parameter))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tsets) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 507 "cil/src/logic/logic_parser.mly"
                                      ( _2 )
# 3212 "cil/src/logic/logic_parser.ml"
               : 'full_tsets))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'ne_lexpr_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 511 "cil/src/logic/logic_parser.mly"
                                             ( _2 )
# 3221 "cil/src/logic/logic_parser.ml"
               : 'full_ne_lexpr_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'logic_type) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 515 "cil/src/logic/logic_parser.mly"
                                          ( _2 )
# 3230 "cil/src/logic/logic_parser.ml"
               : 'full_logic_type))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enter_kw_c_mode) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'assigns) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exit_kw_c_mode) in
    Obj.repr(
# 519 "cil/src/logic/logic_parser.mly"
                                       ( _2 )
# 3239 "cil/src/logic/logic_parser.ml"
               : 'full_assigns))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'location_dep) in
    Obj.repr(
# 523 "cil/src/logic/logic_parser.mly"
               ( _1 )
# 3246 "cil/src/logic/logic_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    Obj.repr(
# 524 "cil/src/logic/logic_parser.mly"
          ( [Nothing,[]] )
# 3252 "cil/src/logic/logic_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    Obj.repr(
# 528 "cil/src/logic/logic_parser.mly"
                ( [] )
# 3258 "cil/src/logic/logic_parser.ml"
               : 'requires))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'full_lexpr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'requires) in
    Obj.repr(
# 529 "cil/src/logic/logic_parser.mly"
                                         ( _2::_4 )
# 3266 "cil/src/logic/logic_parser.ml"
               : 'requires))
; (fun __caml_parser_env ->
    Obj.repr(
# 534 "cil/src/logic/logic_parser.mly"
                ( [],[],[] )
# 3272 "cil/src/logic/logic_parser.ml"
               : 'behavior_body))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ne_behavior_body) in
    Obj.repr(
# 535 "cil/src/logic/logic_parser.mly"
                   ( _1 )
# 3279 "cil/src/logic/logic_parser.ml"
               : 'behavior_body))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'full_lexpr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'behavior_body) in
    Obj.repr(
# 539 "cil/src/logic/logic_parser.mly"
    ( let a,b,c = _4 in _2::a,b,c )
# 3287 "cil/src/logic/logic_parser.ml"
               : 'ne_behavior_body))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'full_lexpr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'behavior_body) in
    Obj.repr(
# 541 "cil/src/logic/logic_parser.mly"
    ( let a,b,c = _4 in a,_2::b,c )
# 3295 "cil/src/logic/logic_parser.ml"
               : 'ne_behavior_body))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'full_assigns) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'behavior_body) in
    Obj.repr(
# 543 "cil/src/logic/logic_parser.mly"
    ( let a,b,c = _4 in
      let assigns =
        match c,_2 with
            ([] | [(Nothing,_) ]), ([] | [(Nothing,_) ]) -> [(Nothing,[])]
          | [(Nothing,_) ], _ | _, [(Nothing,_)] ->
              raise (
                Not_well_formed (loc(),"Mixing \\nothing and a real location"))
          | _,_ -> _2 @ c
      in a,b,assigns
    )
# 3312 "cil/src/logic/logic_parser.ml"
               : 'ne_behavior_body))
; (fun __caml_parser_env ->
    Obj.repr(
# 556 "cil/src/logic/logic_parser.mly"
                ( [] )
# 3318 "cil/src/logic/logic_parser.ml"
               : 'behaviors))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'full_identifier) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'behavior_body) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'behaviors) in
    Obj.repr(
# 558 "cil/src/logic/logic_parser.mly"
      ( let (assumes,ensures,assigns) = _4 in
        Logic_const.check_assigns ~loc:(loc()) assigns;
        {b_name=_2; b_assumes = assumes;
         b_ensures = ensures;
         b_assigns = assigns}::_5 )
# 3331 "cil/src/logic/logic_parser.ml"
               : 'behaviors))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'behavior_body) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'terminates) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'behavior_body) in
    Obj.repr(
# 567 "cil/src/logic/logic_parser.mly"
      ( let (assumes1, ensures1, assigns1) = _1 in
        let (assumes2, ensures2,assigns2) = _3 in
        (Some _2, (assumes1 @ assumes2,
                      ensures1 @ ensures2, assigns1 @ assigns2))
      )
# 3344 "cil/src/logic/logic_parser.ml"
               : 'simple_behavior_body))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'behavior_body) in
    Obj.repr(
# 572 "cil/src/logic/logic_parser.mly"
                ( (None, _1) )
# 3351 "cil/src/logic/logic_parser.ml"
               : 'simple_behavior_body))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'simple_behavior_body) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'behaviors) in
    Obj.repr(
# 577 "cil/src/logic/logic_parser.mly"
    ( let (terminates,(assumes,ensures,assigns)) = _1 in
      let behaviors =
        if (*TODO: enforce to have a default behavior true || *) 
           assumes <> [] || ensures <> [] || assigns <> [] then
          { b_name = "default";b_assumes = assumes;
            b_ensures = ensures;
            b_assigns = assigns} :: _2
        else _2
      in
      terminates, behaviors
    )
# 3369 "cil/src/logic/logic_parser.ml"
               : 'behaviors_or_default))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Logic_ptree.lexpr) in
    Obj.repr(
# 590 "cil/src/logic/logic_parser.mly"
                                       ( _2 )
# 3376 "cil/src/logic/logic_parser.ml"
               : 'terminates))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'full_identifier) in
    Obj.repr(
# 594 "cil/src/logic/logic_parser.mly"
                  ( [_1] )
# 3383 "cil/src/logic/logic_parser.ml"
               : 'ne_full_identifier_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'full_identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ne_full_identifier_list) in
    Obj.repr(
# 595 "cil/src/logic/logic_parser.mly"
                                                (_1 :: _3)
# 3391 "cil/src/logic/logic_parser.ml"
               : 'ne_full_identifier_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 599 "cil/src/logic/logic_parser.mly"
                ( [],[] )
# 3397 "cil/src/logic/logic_parser.ml"
               : 'complete_or_disjoint))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'ne_full_identifier_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'complete_or_disjoint) in
    Obj.repr(
# 601 "cil/src/logic/logic_parser.mly"
      ( let (complete,disjoint) = _5 in (_3::complete, disjoint) )
# 3405 "cil/src/logic/logic_parser.ml"
               : 'complete_or_disjoint))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'ne_full_identifier_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'complete_or_disjoint) in
    Obj.repr(
# 603 "cil/src/logic/logic_parser.mly"
      ( let (complete,disjoint) = _5 in (complete, _3::disjoint) )
# 3413 "cil/src/logic/logic_parser.ml"
               : 'complete_or_disjoint))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'requires) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'behaviors_or_default) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'complete_or_disjoint) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'decreases) in
    Obj.repr(
# 607 "cil/src/logic/logic_parser.mly"
      (
        { spec_requires = _1;
          spec_behavior = snd _2;
          spec_variant = _4;
          spec_terminates = fst _2;
          spec_complete_behaviors = fst _3;
          spec_disjoint_behaviors = snd _3;
        },loc() )
# 3430 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.spec * Cabs.cabsloc))
; (fun __caml_parser_env ->
    Obj.repr(
# 622 "cil/src/logic/logic_parser.mly"
           ( () )
# 3436 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 623 "cil/src/logic/logic_parser.mly"
           ( () )
# 3442 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 624 "cil/src/logic/logic_parser.mly"
          ( () )
# 3448 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 625 "cil/src/logic/logic_parser.mly"
          ( () )
# 3454 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 626 "cil/src/logic/logic_parser.mly"
            ( () )
# 3460 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 627 "cil/src/logic/logic_parser.mly"
             ( () )
# 3466 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    Obj.repr(
# 628 "cil/src/logic/logic_parser.mly"
           ( () )
# 3472 "cil/src/logic/logic_parser.ml"
               : 'is_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'loop_invariant) in
    Obj.repr(
# 632 "cil/src/logic/logic_parser.mly"
                 ( [AInvariant (fst _1,true,snd _1)] )
# 3479 "cil/src/logic/logic_parser.ml"
               : 'loop_annot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'loop_effects) in
    Obj.repr(
# 633 "cil/src/logic/logic_parser.mly"
               ( List.map (fun x -> AAssigns x) _1 )
# 3486 "cil/src/logic/logic_parser.ml"
               : 'loop_annot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'loop_variant) in
    Obj.repr(
# 634 "cil/src/logic/logic_parser.mly"
               ( [AVariant _1] )
# 3493 "cil/src/logic/logic_parser.ml"
               : 'loop_annot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'loop_pragma) in
    Obj.repr(
# 635 "cil/src/logic/logic_parser.mly"
              ( [APragma (Loop_pragma _1)] )
# 3500 "cil/src/logic/logic_parser.ml"
               : 'loop_annot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'loop_annot) in
    Obj.repr(
# 640 "cil/src/logic/logic_parser.mly"
    ( _1 )
# 3507 "cil/src/logic/logic_parser.ml"
               : 'loop_annotations))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'loop_annot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'loop_annotations) in
    Obj.repr(
# 641 "cil/src/logic/logic_parser.mly"
                              ( _1 @ _2 )
# 3515 "cil/src/logic/logic_parser.ml"
               : 'loop_annotations))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 6 : 'full_identifier) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : 'full_parameter) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 647 "cil/src/logic/logic_parser.mly"
  ( let typ,name = _5 in{ inv_name = _3; this_name = name; this_type = typ; inv = _8; } )
# 3524 "cil/src/logic/logic_parser.ml"
               : 'type_annot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'full_lexpr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'full_identifier) in
    Obj.repr(
# 651 "cil/src/logic/logic_parser.mly"
                                 ( (_1, Some _3) )
# 3532 "cil/src/logic/logic_parser.ml"
               : 'variant))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'full_lexpr) in
    Obj.repr(
# 652 "cil/src/logic/logic_parser.mly"
                            ( (_1, None) )
# 3539 "cil/src/logic/logic_parser.ml"
               : 'variant))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'ne_full_identifier_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 657 "cil/src/logic/logic_parser.mly"
    ( (_2,_6) )
# 3547 "cil/src/logic/logic_parser.ml"
               : 'loop_invariant))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 658 "cil/src/logic/logic_parser.mly"
                                      ( ([],_3) )
# 3554 "cil/src/logic/logic_parser.ml"
               : 'loop_invariant))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'variant) in
    Obj.repr(
# 662 "cil/src/logic/logic_parser.mly"
                                 ( _3 )
# 3561 "cil/src/logic/logic_parser.ml"
               : 'loop_variant))
; (fun __caml_parser_env ->
    Obj.repr(
# 666 "cil/src/logic/logic_parser.mly"
                  ( None )
# 3567 "cil/src/logic/logic_parser.ml"
               : 'decreases))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'variant) in
    Obj.repr(
# 667 "cil/src/logic/logic_parser.mly"
                              ( Some _2 )
# 3574 "cil/src/logic/logic_parser.ml"
               : 'decreases))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'slice_pragma) in
    Obj.repr(
# 671 "cil/src/logic/logic_parser.mly"
                   ( APragma (Slice_pragma _1) )
# 3581 "cil/src/logic/logic_parser.ml"
               : 'code_annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'impact_pragma) in
    Obj.repr(
# 672 "cil/src/logic/logic_parser.mly"
                   ( APragma (Impact_pragma _1) )
# 3588 "cil/src/logic/logic_parser.ml"
               : 'code_annotation))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ne_full_identifier_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 674 "cil/src/logic/logic_parser.mly"
      ( AAssert (_2,_5,{status=Cil_types.Unknown}) )
# 3596 "cil/src/logic/logic_parser.ml"
               : 'code_annotation))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 675 "cil/src/logic/logic_parser.mly"
                                 ( AAssert ([],_2,{status=Cil_types.Unknown}) )
# 3603 "cil/src/logic/logic_parser.ml"
               : 'code_annotation))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 676 "cil/src/logic/logic_parser.mly"
                                 ( AInvariant ([],false,_2) )
# 3610 "cil/src/logic/logic_parser.ml"
               : 'code_annotation))
; (fun __caml_parser_env ->
    Obj.repr(
# 680 "cil/src/logic/logic_parser.mly"
              ( )
# 3616 "cil/src/logic/logic_parser.ml"
               : 'loop_pragma_tk))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'loop_pragma_tk) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'full_ne_lexpr_list) in
    Obj.repr(
# 685 "cil/src/logic/logic_parser.mly"
  ( if _2 = "UNROLL_LOOP" || _2 = "UNROLL" then
      match _3 with
        | [level] -> Unroll_level level
        | _ -> raise(
            Not_well_formed(loc(),"usage: loop pragma UNROLL n;"))
    else if _2 = "WIDEN_VARIABLES" then
      Widen_variables _3
    else if _2 = "WIDEN_HINTS" then
      Widen_hints _3
    else raise (Not_well_formed (loc(),"unknown loop pragma")) )
# 3634 "cil/src/logic/logic_parser.ml"
               : 'loop_pragma))
; (fun __caml_parser_env ->
    Obj.repr(
# 697 "cil/src/logic/logic_parser.mly"
               ( )
# 3640 "cil/src/logic/logic_parser.ml"
               : 'slice_pragma_tk))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'slice_pragma_tk) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 702 "cil/src/logic/logic_parser.mly"
    ( if _2 = "expr" then SPexpr _3
      else raise (Not_well_formed (loc(), "unknown slice pragma")) )
# 3650 "cil/src/logic/logic_parser.ml"
               : 'slice_pragma))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'slice_pragma_tk) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 705 "cil/src/logic/logic_parser.mly"
    ( if _2 = "ctrl" then SPctrl
      else if _2 = "stmt" then SPstmt
      else raise (Not_well_formed (loc(), "unknown slice pragma")) )
# 3660 "cil/src/logic/logic_parser.ml"
               : 'slice_pragma))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 711 "cil/src/logic/logic_parser.mly"
    ( if _3 = "expr" then IPexpr _4
      else raise (Not_well_formed (loc(), "unknown impact pragma")) )
# 3669 "cil/src/logic/logic_parser.ml"
               : 'impact_pragma))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 714 "cil/src/logic/logic_parser.mly"
    ( if _3 = "stmt" then IPstmt
      else raise (Not_well_formed (loc(), "unknown impact pragma")) )
# 3677 "cil/src/logic/logic_parser.ml"
               : 'impact_pragma))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'full_assigns) in
    Obj.repr(
# 718 "cil/src/logic/logic_parser.mly"
                                      ( _3 )
# 3684 "cil/src/logic/logic_parser.ml"
               : 'loop_effects))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'zones) in
    Obj.repr(
# 722 "cil/src/logic/logic_parser.mly"
        ( List.map (fun x -> (x,[])) _1 )
# 3691 "cil/src/logic/logic_parser.ml"
               : 'location_dep))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'zones) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'zones) in
    Obj.repr(
# 723 "cil/src/logic/logic_parser.mly"
                   (List.map (fun x -> (x, _3)) _1)
# 3699 "cil/src/logic/logic_parser.ml"
               : 'location_dep))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'zones) in
    Obj.repr(
# 724 "cil/src/logic/logic_parser.mly"
                      (List.map (fun x -> (x, [Nothing])) _1)
# 3706 "cil/src/logic/logic_parser.ml"
               : 'location_dep))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tsets) in
    Obj.repr(
# 726 "cil/src/logic/logic_parser.mly"
              ( List.map (fun x -> Location x) _1 )
# 3713 "cil/src/logic/logic_parser.ml"
               : 'zones))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'location) in
    Obj.repr(
# 729 "cil/src/logic/logic_parser.mly"
           ( [_1] )
# 3720 "cil/src/logic/logic_parser.ml"
               : 'tsets))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'location) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tsets) in
    Obj.repr(
# 730 "cil/src/logic/logic_parser.mly"
                       ( _1 :: _3 )
# 3728 "cil/src/logic/logic_parser.ml"
               : 'tsets))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.lexpr) in
    Obj.repr(
# 734 "cil/src/logic/logic_parser.mly"
        ( _1 )
# 3735 "cil/src/logic/logic_parser.ml"
               : 'location))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'full_identifier) in
    Obj.repr(
# 748 "cil/src/logic/logic_parser.mly"
                  ( (_1,[],[]) )
# 3742 "cil/src/logic/logic_parser.ml"
               : 'poly_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'full_identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_tvar_list) in
    Obj.repr(
# 749 "cil/src/logic/logic_parser.mly"
                                     ( _1,[],_3 )
# 3750 "cil/src/logic/logic_parser.ml"
               : 'poly_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'full_identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'ne_label_list) in
    Obj.repr(
# 750 "cil/src/logic/logic_parser.mly"
                                              ( (_1,_3,[]) )
# 3758 "cil/src/logic/logic_parser.ml"
               : 'poly_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'full_identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'ne_label_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'ne_tvar_list) in
    Obj.repr(
# 751 "cil/src/logic/logic_parser.mly"
                                                                 ( _1,_3,_6 )
# 3767 "cil/src/logic/logic_parser.ml"
               : 'poly_id))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 754 "cil/src/logic/logic_parser.mly"
             ( _1 )
# 3774 "cil/src/logic/logic_parser.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    Obj.repr(
# 758 "cil/src/logic/logic_parser.mly"
              ( [] )
# 3780 "cil/src/logic/logic_parser.ml"
               : 'opt_parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameters) in
    Obj.repr(
# 759 "cil/src/logic/logic_parser.mly"
             ( _1 )
# 3787 "cil/src/logic/logic_parser.ml"
               : 'opt_parameters))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'full_parameters) in
    Obj.repr(
# 763 "cil/src/logic/logic_parser.mly"
                            ( _2 )
# 3794 "cil/src/logic/logic_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'logic_def) in
    Obj.repr(
# 767 "cil/src/logic/logic_parser.mly"
             ( _1 )
# 3801 "cil/src/logic/logic_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'deprecated_logic_decl) in
    Obj.repr(
# 769 "cil/src/logic/logic_parser.mly"
    ( _1 )
# 3808 "cil/src/logic/logic_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'full_identifier) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 771 "cil/src/logic/logic_parser.mly"
    ( LDinvariant (_3, _5) )
# 3816 "cil/src/logic/logic_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_annot) in
    Obj.repr(
# 772 "cil/src/logic/logic_parser.mly"
             (LDtype_annot _1)
# 3823 "cil/src/logic/logic_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'full_logic_type) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'poly_id) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'opt_parameters) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 778 "cil/src/logic/logic_parser.mly"
    ( let (id, labels, tvars) = _3 in
      LDlogic_def (id, labels, tvars, _2, _4, _6) )
# 3834 "cil/src/logic/logic_parser.ml"
               : 'logic_def))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'poly_id) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'opt_parameters) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 782 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      LDpredicate_def (id, labels, tvars, _3, _5) )
# 3844 "cil/src/logic/logic_parser.ml"
               : 'logic_def))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'poly_id) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'parameters) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'indcases) in
    Obj.repr(
# 786 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      LDinductive_def(id, labels, tvars, _3, _5) )
# 3854 "cil/src/logic/logic_parser.ml"
               : 'logic_def))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'poly_id) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 789 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      LDlemma (id, false, labels, tvars, _4) )
# 3863 "cil/src/logic/logic_parser.ml"
               : 'logic_def))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'logic_decls) in
    Obj.repr(
# 792 "cil/src/logic/logic_parser.mly"
    ( LDaxiomatic(_2,_4) )
# 3871 "cil/src/logic/logic_parser.ml"
               : 'logic_def))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'full_logic_type) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'poly_id) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'opt_parameters) in
    Obj.repr(
# 798 "cil/src/logic/logic_parser.mly"
    ( let (id, labels, tvars) = _3 in
      Format.eprintf "Warning: deprecated logic declaration '%s', should be declared inside an axiomatic block@." id;
      LDlogic_reads (id, labels, tvars, _2, _4, []) )
# 3882 "cil/src/logic/logic_parser.ml"
               : 'deprecated_logic_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'poly_id) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'opt_parameters) in
    Obj.repr(
# 803 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      Format.eprintf "Warning: deprecated logic declaration `%s', should be declared inside an axiomatic block@." id;
      LDpredicate_reads (id, labels, tvars, _3, []) )
# 3892 "cil/src/logic/logic_parser.ml"
               : 'deprecated_logic_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'poly_id) in
    Obj.repr(
# 808 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      assert (labels = []);
      Format.eprintf "Warning: deprecated logic type declaration `%s', should be declared inside an axiomatic block@." id;
      LDtype(id,tvars) )
# 3902 "cil/src/logic/logic_parser.ml"
               : 'deprecated_logic_decl))
; (fun __caml_parser_env ->
    Obj.repr(
# 817 "cil/src/logic/logic_parser.mly"
    ( [] )
# 3908 "cil/src/logic/logic_parser.ml"
               : 'logic_decls))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'logic_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'logic_decls) in
    Obj.repr(
# 819 "cil/src/logic/logic_parser.mly"
    ( _1::_2 )
# 3916 "cil/src/logic/logic_parser.ml"
               : 'logic_decls))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'logic_def) in
    Obj.repr(
# 823 "cil/src/logic/logic_parser.mly"
             ( _1 )
# 3923 "cil/src/logic/logic_parser.ml"
               : 'logic_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'full_logic_type) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'poly_id) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'opt_parameters) in
    Obj.repr(
# 826 "cil/src/logic/logic_parser.mly"
    ( let (id, labels, tvars) = _3 in
      LDlogic_reads (id, labels, tvars, _2, _4, []) )
# 3933 "cil/src/logic/logic_parser.ml"
               : 'logic_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'poly_id) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'opt_parameters) in
    Obj.repr(
# 830 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      LDpredicate_reads (id, labels, tvars, _3, []) )
# 3942 "cil/src/logic/logic_parser.ml"
               : 'logic_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'poly_id) in
    Obj.repr(
# 834 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      assert (labels = []);
      LDtype(id,tvars) )
# 3951 "cil/src/logic/logic_parser.ml"
               : 'logic_decl))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'poly_id) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'full_lexpr) in
    Obj.repr(
# 840 "cil/src/logic/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      LDlemma (id, true, labels, tvars, _4) )
# 3960 "cil/src/logic/logic_parser.ml"
               : 'logic_decl))
; (fun __caml_parser_env ->
    Obj.repr(
# 847 "cil/src/logic/logic_parser.mly"
    ( [] )
# 3966 "cil/src/logic/logic_parser.ml"
               : 'indcases))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Logic_ptree.lexpr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'indcases) in
    Obj.repr(
# 849 "cil/src/logic/logic_parser.mly"
    ( (_2,_4)::_6 )
# 3975 "cil/src/logic/logic_parser.ml"
               : 'indcases))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'full_identifier) in
    Obj.repr(
# 854 "cil/src/logic/logic_parser.mly"
                  ( [_1] )
# 3982 "cil/src/logic/logic_parser.ml"
               : 'ne_tvar_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'full_identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ne_tvar_list) in
    Obj.repr(
# 855 "cil/src/logic/logic_parser.mly"
                                     ( _1 :: _3 )
# 3990 "cil/src/logic/logic_parser.ml"
               : 'ne_tvar_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'label) in
    Obj.repr(
# 859 "cil/src/logic/logic_parser.mly"
        ( [_1] )
# 3997 "cil/src/logic/logic_parser.ml"
               : 'ne_label_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'label) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ne_label_list) in
    Obj.repr(
# 860 "cil/src/logic/logic_parser.mly"
                            ( _1 :: _3 )
# 4005 "cil/src/logic/logic_parser.ml"
               : 'ne_label_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'full_identifier) in
    Obj.repr(
# 864 "cil/src/logic/logic_parser.mly"
                  ( _1 )
# 4012 "cil/src/logic/logic_parser.ml"
               : 'label))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'annotation) in
    Obj.repr(
# 868 "cil/src/logic/logic_parser.mly"
                   ( _1 )
# 4019 "cil/src/logic/logic_parser.ml"
               : Logic_ptree.annot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 872 "cil/src/logic/logic_parser.mly"
       ( [(loc(), _1)] )
# 4026 "cil/src/logic/logic_parser.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_list) in
    Obj.repr(
# 873 "cil/src/logic/logic_parser.mly"
                 ( (loc(),_1) :: _2 )
# 4034 "cil/src/logic/logic_parser.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_list) in
    Obj.repr(
# 876 "cil/src/logic/logic_parser.mly"
                        ( Adecl (_1) )
# 4041 "cil/src/logic/logic_parser.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'is_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'any) in
    Obj.repr(
# 877 "cil/src/logic/logic_parser.mly"
                   ( Aspec )
# 4049 "cil/src/logic/logic_parser.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'loop_annotations) in
    Obj.repr(
# 878 "cil/src/logic/logic_parser.mly"
                   ( Logic_const.check_loop_annotation ~loc:(loc()) _1;
                     Aloop_annot (loc (), _1) )
# 4057 "cil/src/logic/logic_parser.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'code_annotation) in
    Obj.repr(
# 880 "cil/src/logic/logic_parser.mly"
                  ( Acode_annot (loc(),_1) )
# 4064 "cil/src/logic/logic_parser.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 881 "cil/src/logic/logic_parser.mly"
                  ( Aattribute_annot (loc (), _1) )
# 4071 "cil/src/logic/logic_parser.ml"
               : 'annotation))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'wildcard) in
    Obj.repr(
# 886 "cil/src/logic/logic_parser.mly"
           ( () )
# 4078 "cil/src/logic/logic_parser.ml"
               : 'any))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'wildcard) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'any) in
    Obj.repr(
# 887 "cil/src/logic/logic_parser.mly"
               ( () )
# 4086 "cil/src/logic/logic_parser.ml"
               : 'any))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 891 "cil/src/logic/logic_parser.mly"
             ( () )
# 4093 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 892 "cil/src/logic/logic_parser.mly"
                 ( () )
# 4100 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 893 "cil/src/logic/logic_parser.mly"
           ( () )
# 4107 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Logic_ptree.constant) in
    Obj.repr(
# 894 "cil/src/logic/logic_parser.mly"
           ( () )
# 4114 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 895 "cil/src/logic/logic_parser.mly"
       ( () )
# 4120 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 896 "cil/src/logic/logic_parser.mly"
       ( () )
# 4126 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 897 "cil/src/logic/logic_parser.mly"
     ( () )
# 4132 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 898 "cil/src/logic/logic_parser.mly"
       ( () )
# 4138 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 899 "cil/src/logic/logic_parser.mly"
        ( () )
# 4144 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 900 "cil/src/logic/logic_parser.mly"
         ( () )
# 4150 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 901 "cil/src/logic/logic_parser.mly"
             ( () )
# 4156 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 902 "cil/src/logic/logic_parser.mly"
      ( () )
# 4162 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 903 "cil/src/logic/logic_parser.mly"
         ( () )
# 4168 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 904 "cil/src/logic/logic_parser.mly"
            ( () )
# 4174 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 905 "cil/src/logic/logic_parser.mly"
      ( () )
# 4180 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 906 "cil/src/logic/logic_parser.mly"
          ( () )
# 4186 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 907 "cil/src/logic/logic_parser.mly"
       ( () )
# 4192 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 908 "cil/src/logic/logic_parser.mly"
        ( () )
# 4198 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 909 "cil/src/logic/logic_parser.mly"
     ( () )
# 4204 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 910 "cil/src/logic/logic_parser.mly"
     ( () )
# 4210 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 911 "cil/src/logic/logic_parser.mly"
     ( () )
# 4216 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 912 "cil/src/logic/logic_parser.mly"
     ( () )
# 4222 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 913 "cil/src/logic/logic_parser.mly"
     ( () )
# 4228 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 914 "cil/src/logic/logic_parser.mly"
     ( () )
# 4234 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 915 "cil/src/logic/logic_parser.mly"
        ( () )
# 4240 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 916 "cil/src/logic/logic_parser.mly"
        ( () )
# 4246 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 917 "cil/src/logic/logic_parser.mly"
        ( () )
# 4252 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 918 "cil/src/logic/logic_parser.mly"
         ( () )
# 4258 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 919 "cil/src/logic/logic_parser.mly"
         ( () )
# 4264 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 920 "cil/src/logic/logic_parser.mly"
      ( () )
# 4270 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 921 "cil/src/logic/logic_parser.mly"
          ( () )
# 4276 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 922 "cil/src/logic/logic_parser.mly"
      ( () )
# 4282 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 923 "cil/src/logic/logic_parser.mly"
     ( () )
# 4288 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 924 "cil/src/logic/logic_parser.mly"
      ( () )
# 4294 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 925 "cil/src/logic/logic_parser.mly"
       ( () )
# 4300 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 926 "cil/src/logic/logic_parser.mly"
        ( () )
# 4306 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 927 "cil/src/logic/logic_parser.mly"
      ( () )
# 4312 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 928 "cil/src/logic/logic_parser.mly"
     ( () )
# 4318 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 929 "cil/src/logic/logic_parser.mly"
         ( () )
# 4324 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 930 "cil/src/logic/logic_parser.mly"
               ( () )
# 4330 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 931 "cil/src/logic/logic_parser.mly"
            ( () )
# 4336 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 932 "cil/src/logic/logic_parser.mly"
        ( () )
# 4342 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 933 "cil/src/logic/logic_parser.mly"
              ( () )
# 4348 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 934 "cil/src/logic/logic_parser.mly"
              ( () )
# 4354 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 935 "cil/src/logic/logic_parser.mly"
        ( () )
# 4360 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 936 "cil/src/logic/logic_parser.mly"
         ( () )
# 4366 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 937 "cil/src/logic/logic_parser.mly"
           ( () )
# 4372 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 938 "cil/src/logic/logic_parser.mly"
        ( () )
# 4378 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 939 "cil/src/logic/logic_parser.mly"
       ( () )
# 4384 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 940 "cil/src/logic/logic_parser.mly"
       ( () )
# 4390 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 941 "cil/src/logic/logic_parser.mly"
      ( () )
# 4396 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 942 "cil/src/logic/logic_parser.mly"
        ( () )
# 4402 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 943 "cil/src/logic/logic_parser.mly"
          ( () )
# 4408 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 944 "cil/src/logic/logic_parser.mly"
          ( () )
# 4414 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 945 "cil/src/logic/logic_parser.mly"
          ( () )
# 4420 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 946 "cil/src/logic/logic_parser.mly"
         ( () )
# 4426 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 947 "cil/src/logic/logic_parser.mly"
            ( () )
# 4432 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 948 "cil/src/logic/logic_parser.mly"
          ( () )
# 4438 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 949 "cil/src/logic/logic_parser.mly"
            ( () )
# 4444 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 950 "cil/src/logic/logic_parser.mly"
      ( () )
# 4450 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 951 "cil/src/logic/logic_parser.mly"
        ( () )
# 4456 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 952 "cil/src/logic/logic_parser.mly"
         ( () )
# 4462 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 953 "cil/src/logic/logic_parser.mly"
            ( () )
# 4468 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 954 "cil/src/logic/logic_parser.mly"
       ( () )
# 4474 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 955 "cil/src/logic/logic_parser.mly"
        ( () )
# 4480 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 956 "cil/src/logic/logic_parser.mly"
           ( () )
# 4486 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 957 "cil/src/logic/logic_parser.mly"
          ( () )
# 4492 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 958 "cil/src/logic/logic_parser.mly"
          ( () )
# 4498 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 959 "cil/src/logic/logic_parser.mly"
       ( () )
# 4504 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 960 "cil/src/logic/logic_parser.mly"
          ( () )
# 4510 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 961 "cil/src/logic/logic_parser.mly"
        ( () )
# 4516 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 962 "cil/src/logic/logic_parser.mly"
         ( () )
# 4522 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 963 "cil/src/logic/logic_parser.mly"
       ( () )
# 4528 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 964 "cil/src/logic/logic_parser.mly"
        ( () )
# 4534 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 965 "cil/src/logic/logic_parser.mly"
        ( () )
# 4540 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 966 "cil/src/logic/logic_parser.mly"
            ( () )
# 4546 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 967 "cil/src/logic/logic_parser.mly"
        ( () )
# 4552 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 968 "cil/src/logic/logic_parser.mly"
        ( () )
# 4558 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 969 "cil/src/logic/logic_parser.mly"
         ( () )
# 4564 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 970 "cil/src/logic/logic_parser.mly"
         ( () )
# 4570 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 971 "cil/src/logic/logic_parser.mly"
        ( () )
# 4576 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 972 "cil/src/logic/logic_parser.mly"
       ( () )
# 4582 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 973 "cil/src/logic/logic_parser.mly"
       ( () )
# 4588 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 974 "cil/src/logic/logic_parser.mly"
         ( () )
# 4594 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 975 "cil/src/logic/logic_parser.mly"
           ( () )
# 4600 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 976 "cil/src/logic/logic_parser.mly"
        ( () )
# 4606 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 977 "cil/src/logic/logic_parser.mly"
       ( () )
# 4612 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 978 "cil/src/logic/logic_parser.mly"
         ( () )
# 4618 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 979 "cil/src/logic/logic_parser.mly"
         ( () )
# 4624 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 980 "cil/src/logic/logic_parser.mly"
       ( () )
# 4630 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 981 "cil/src/logic/logic_parser.mly"
        ( () )
# 4636 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 982 "cil/src/logic/logic_parser.mly"
          ( () )
# 4642 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 983 "cil/src/logic/logic_parser.mly"
        ( () )
# 4648 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 984 "cil/src/logic/logic_parser.mly"
          ( () )
# 4654 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 985 "cil/src/logic/logic_parser.mly"
          ( () )
# 4660 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 986 "cil/src/logic/logic_parser.mly"
       ( () )
# 4666 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 987 "cil/src/logic/logic_parser.mly"
           ( () )
# 4672 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 988 "cil/src/logic/logic_parser.mly"
          ( () )
# 4678 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 989 "cil/src/logic/logic_parser.mly"
      ( () )
# 4684 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 990 "cil/src/logic/logic_parser.mly"
         ( () )
# 4690 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 991 "cil/src/logic/logic_parser.mly"
       ( () )
# 4696 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 992 "cil/src/logic/logic_parser.mly"
        ( () )
# 4702 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 993 "cil/src/logic/logic_parser.mly"
       ( () )
# 4708 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 994 "cil/src/logic/logic_parser.mly"
       ( () )
# 4714 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 995 "cil/src/logic/logic_parser.mly"
         ( () )
# 4720 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 996 "cil/src/logic/logic_parser.mly"
           ( () )
# 4726 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 997 "cil/src/logic/logic_parser.mly"
            ( () )
# 4732 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 998 "cil/src/logic/logic_parser.mly"
           ( () )
# 4738 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 999 "cil/src/logic/logic_parser.mly"
             ( () )
# 4744 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 1000 "cil/src/logic/logic_parser.mly"
         ( () )
# 4750 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 1001 "cil/src/logic/logic_parser.mly"
         ( () )
# 4756 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 1002 "cil/src/logic/logic_parser.mly"
         ( () )
# 4762 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
; (fun __caml_parser_env ->
    Obj.repr(
# 1003 "cil/src/logic/logic_parser.mly"
            ( () )
# 4768 "cil/src/logic/logic_parser.ml"
               : 'wildcard))
(* Entry lexpr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry annot *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry spec *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let lexpr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Logic_ptree.lexpr)
let annot (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Logic_ptree.annot)
let spec (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Logic_ptree.spec * Cabs.cabsloc)
;;
